<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

// get database connection
//include_once '../config/database_multiplicity.php';

// instantiate uids object
//include_once '../objects/uids.php';
//include_once '../objects/users.php';
//include_once '../objects/services.php';
//include_once '../objects/apikeys.php';
//include_once '../objects/apilogs.php';

if (file_exists('../config/database_multiplicity.php')) {include_once('../config/database_multiplicity.php');}

if (file_exists('../objects/uids.php')) {include_once('../objects/uids.php');}
if (file_exists('../objects/users.php')) {include_once('../objects/users.php');}
if (file_exists('../objects/services.php')) {include_once('../objects/services.php');}
if (file_exists('../objects/apikeys.php')) {include_once('../objects/apikeys.php');}
if (file_exists('../objects/apilogs.php')) {include_once('../objects/apilogs.php');}

/*    Validate API
**  Params : 
      reqBy   --> Api Key
      secret  --> Secret key

    Returns :
      - Blob (array) :
        message --> Status message
        apiKey --> Array of all API structure
        identity --> Array User/Service identity structure
        reqBy --> String of who has requested
        
      (
          [ID] => 1
          [CREATED] => 2022-11-29 15:19:54
          [UPDATED] => 2022-11-30 17:32:28
          [API_KEY] => toto1234
          [IS_USER] => 0
          [FOREIGN_ID] => 1
          [IS_ACTIVE] => 1
      )
      Array
      (
          [ID] => 1
          [CREATED] => 2022-11-29 15:00:01
          [UPDATED] => 2023-01-24 18:24:45
          [TRIGRAM] => netbalancer
          [IS_ACTIVE] => 1
      )

**
*/

function validateApiKey($reqBy) {
  $api_Service = 'getUniqId';

  $database = new Database();
  $db = $database->getConnection();

  $uids = new uids($db);
  $apiKeys = new apiKeys($db);
  $users = new users($db);
  $services = new services($db);
  $apiLogs = new apiLogs($db);

  $apiKeys->apiKey = $reqBy; // store reqBy
  $apiKeys->readOne();
  $apiKeys_arr = array(
    "ID" => $apiKeys->apiKeyID,
    "CREATED" => $apiKeys->created,
    "UPDATED" => $apiKeys->updated,
    "DESCRIPTION" => $apiKeys->description,
    "API_KEY" => $apiKeys->apiKey,
    "IS_USER" => $apiKeys->isUser,
    "FOREIGN_ID" => $apiKeys->foreignID,
    "IS_ACTIVE" => $apiKeys->isActive
  );
  //print_r(json_encode($apiKeys_arr));
  //die();

  $users->userID = $apiKeys->foreignID;

  ## Check 1 : Is API Key Active ?
  if ($apiKeys->apiKeyID == null) {
    echo '{', PHP_EOL, '"message": "Error : apiKey \'' . $apiKeys->apiKey . '\' does not exist."', PHP_EOL, '}';
    die();
  } elseif ($apiKeys->isActive == "0" ) {
    echo '{', PHP_EOL, '"message": "Error : apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';
    die();  
  } else {
    // API Key exists
    if ($apiKeys->isUser == 1) { // User
      // User
      $users->readOne();
      $indentifier_arr = array(
        "ID" => $users->userID,
        "CREATED" => $users->created,
        "UPDATED" => $users->updated,
        "TRIGRAM" => $users->trigram,
        "TRIGRAM_KEY" => $users->trigramKey,
        "SESSION_COOKIE" => $users->sessionCookie,
        "FNAME" => $users->firstName,
        "LNAME" => $users->lastName,
        "IS_ACTIVE" => $users->isActive,
        "WEB_SECRET" => $users->webSecret 
      );

      // is User Active ?
      if ($users->isActive == 0) {
        echo '{', PHP_EOL, '"message": "Error : user associated to apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';

        writeAPILog($apiLogs, $apiKeys->apiKey, $api_Service, 0, "Error: user is not active");

        die();
      } else {
        $tmpReqByName = $users->trigram;
        $identity_msg = '"Working ! : user associated to apiKey \'' . $apiKeys->apiKey . '\' is active."';
      }
    } else { // Service
      $services->serviceID = $apiKeys->foreignID;
      $services->readOne();
      $indentifier_arr = array(
        "ID" => $services->serviceID,
        "CREATED" => $services->created,
        "UPDATED" => $services->updated,
        "SVC_NAME" => $services->serviceName,
        "IS_ACTIVE" => $services->isActive
      );

      if ($services->isActive == 0) {
        echo '{', PHP_EOL, '"message": "Error : service associated to apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';

        writeAPILog($apiLogs, $apiKeys->apiKey, $api_Service, 0, "Error: user is not active");
        
        die();
      } else {
        // user is active ==> Log ==> Done 
        //echo '{', PHP_EOL, '"message": "Working ! : user associated to apiKey \'' . $apiKeys->apiKey . '\' is active."', PHP_EOL, '}';
        $tmpReqByName = $services->serviceName;
        $identity_msg = '"Working ! : service associated to apiKey \'' . $apiKeys->apiKey . '\' is active."';
      }    

    }
  }
  $blob = array(
    "message" => $identity_msg,
    "APIKEY" => $apiKeys_arr,
    "IDENTITY" => $indentifier_arr,
    "REQBY" => $tmpReqByName
  );

  return $blob;
}


?>
