<?php
class hosts{

    // database connection and table clientKey
    private $conn;
    private $table_HOSTS = "T_HOSTS";

    // object properties
    public $host_ID;
    public $host_hostingStack;
    public $host_os;
    public $host_site;
    public $host_pubIP;
    public $host_appxLocation;
    public $host_created;
    public $host_updated;
    public $host_hostType;
    public $host_ownedBy;
    public $host_hostUID;
    public $host_ramUsed;
    public $host_ramTotal;
    public $host_cpuUsed;
    public $host_diskUsage;
    public $host_regStatus;
    public $host_status;
    public $host_lastSeen;
    public $host_masterKey;

    public $host_retCount;
    // constructor with $db as database connection
    public function __construct($db){
        $this->conn = $db;
    }

    // read all hosts
/*    function read(){
        $query = "
        SELECT actionID, timestamp, askedByClient, targetPodUID, targetRelayID, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_HOSTS . "
        GROUP BY targetPodUID
        ORDER BY timestamp DESC";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        // execute query
        $stmt->execute();

        return $stmt;
    }
*/

    /*  READ ONE
    **  : From ID
    **  Returns 1 Matching result
    **
    */
    function readOne() {
        // ID is obfuscated
        $query = "
        SELECT ID, HOSTING_STACK, OS, SITE, PUB_IP, APPX_LOC, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_HOSTS . "
        WHERE `ID` = '" . $this->host_ID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->host_ID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->host_ID=htmlspecialchars(strip_tags($this->host_ID));
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));
        $this->host_os=htmlspecialchars(strip_tags($this->host_os));
        $this->host_site=htmlspecialchars(strip_tags($this->host_site));
        $this->host_pubIP=htmlspecialchars(strip_tags($this->host_pubIP));
        $this->host_appxLocation=htmlspecialchars(strip_tags($this->host_appxLocation));
        $this->host_created=htmlspecialchars(strip_tags($this->host_created));
        $this->host_updated=htmlspecialchars(strip_tags($this->host_updated));
        $this->host_hostType=htmlspecialchars(strip_tags($this->host_hostType));
        $this->host_ownedBy=htmlspecialchars(strip_tags($this->host_ownedBy));
        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_ramUsed=htmlspecialchars(strip_tags($this->host_ramUsed));
        $this->host_ramTotal=htmlspecialchars(strip_tags($this->host_ramTotal));
        $this->host_cpuUsed=htmlspecialchars(strip_tags($this->host_cpuUsed));
        $this->host_diskUsage=htmlspecialchars(strip_tags($this->host_diskUsage));
        $this->host_regStatus=htmlspecialchars(strip_tags($this->host_regStatus));
        $this->host_status=htmlspecialchars(strip_tags($this->host_status));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        $this->host_masterKey=htmlspecialchars(strip_tags($this->host_masterKey));


        // set values to object properties
        $this->host_ID = $row['ID'];
        $this->host_hostingStack = $row['HOSTING_STACK'];
        $this->host_os = $row['OS'];
        $this->host_site = $row['SITE'];
        $this->host_pubIP = $row['PUB_IP'];
        $this->host_appxLocation = $row['APPX_LOC'];
        $this->host_created = $row['CREATED'];
        $this->host_updated = $row['UPDATED'];
        $this->host_hostType = $row['HOST_TYPE'];
        $this->host_ownedBy = $row['OWNED_BY'];
        $this->host_hostUID = $row['HOST_UID'];
        $this->host_ramUsed = $row['RAM_USED'];
        $this->host_ramTotal = $row['RAM_TOTAL'];
        $this->host_cpuUsed = $row['CPU_USED'];
        $this->host_diskUsage = $row['DISK_USAGE'];
        $this->host_regStatus = $row['REG_STATUS'];
        $this->host_status = $row['STATUS'];
        $this->host_lastSeen = $row['LAST_SEEN'];


        if ( $this->host_masterKey != "alpine" ) {
            $this->host_ID = "obfuscated";
        }
        //var_dump($this->userID);
    }

    function readOneFromUID() {
        // ID is obfuscated

        /*  Read One Host : 
        **  
        **
        **
        */

        $query = "
        SELECT ID, HOSTING_STACK, OS, SITE, PUB_IP, APPX_LOC, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_HOSTS . "
        WHERE `HOST_UID` = '" . $this->host_hostUID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->host_hostUID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->host_ID=htmlspecialchars(strip_tags($this->host_ID));
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));
        $this->host_os=htmlspecialchars(strip_tags($this->host_os));
        $this->host_site=htmlspecialchars(strip_tags($this->host_site));
        $this->host_pubIP=htmlspecialchars(strip_tags($this->host_pubIP));
        $this->host_appxLocation=htmlspecialchars(strip_tags($this->host_appxLocation));
        $this->host_created=htmlspecialchars(strip_tags($this->host_created));
        $this->host_updated=htmlspecialchars(strip_tags($this->host_updated));
        $this->host_hostType=htmlspecialchars(strip_tags($this->host_hostType));
        $this->host_ownedBy=htmlspecialchars(strip_tags($this->host_ownedBy));
        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_ramUsed=htmlspecialchars(strip_tags($this->host_ramUsed));
        $this->host_ramTotal=htmlspecialchars(strip_tags($this->host_ramTotal));
        $this->host_cpuUsed=htmlspecialchars(strip_tags($this->host_cpuUsed));
        $this->host_diskUsage=htmlspecialchars(strip_tags($this->host_diskUsage));
        $this->host_regStatus=htmlspecialchars(strip_tags($this->host_regStatus));
        $this->host_status=htmlspecialchars(strip_tags($this->host_status));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        $this->host_masterKey=htmlspecialchars(strip_tags($this->host_masterKey));


        // set values to object properties
        $this->host_ID = $row['ID'];
        $this->host_hostingStack = $row['HOSTING_STACK'];
        $this->host_os = $row['OS'];
        $this->host_site = $row['SITE'];
        $this->host_pubIP = $row['PUB_IP'];
        $this->host_appxLocation = $row['APPX_LOC'];
        $this->host_created = $row['CREATED'];
        $this->host_updated = $row['UPDATED'];
        $this->host_hostType = $row['HOST_TYPE'];
        $this->host_ownedBy = $row['OWNED_BY'];
        $this->host_hostUID = $row['HOST_UID'];
        $this->host_ramUsed = $row['RAM_USED'];
        $this->host_ramTotal = $row['RAM_TOTAL'];
        $this->host_cpuUsed = $row['CPU_USED'];
        $this->host_diskUsage = $row['DISK_USAGE'];
        $this->host_regStatus = $row['REG_STATUS'];
        $this->host_status = $row['STATUS'];
        $this->host_lastSeen = $row['LAST_SEEN'];

        //if ( $this->host_masterKey != "alpine" ) {
        //    $this->host_ID = "obfuscated";
        //}
        //var_dump($this->userID);
    }

    function readOneFromHostingStackID() {
        // ID is obfuscated
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));

        /*  Read One Host : 
        **  
        **
        **
        */

        $query = "
        SELECT ID, HOSTING_STACK, OS, SITE, PUB_IP, APPX_LOC, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_HOSTS . "
        WHERE `HOSTING_STACK` = '" . $this->host_hostingStack . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->host_hostingStack);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->host_ID=htmlspecialchars(strip_tags($this->host_ID));
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));
        $this->host_os=htmlspecialchars(strip_tags($this->host_os));
        $this->host_site=htmlspecialchars(strip_tags($this->host_site));
        $this->host_pubIP=htmlspecialchars(strip_tags($this->host_pubIP));
        $this->host_appxLocation=htmlspecialchars(strip_tags($this->host_appxLocation));
        $this->host_created=htmlspecialchars(strip_tags($this->host_created));
        $this->host_updated=htmlspecialchars(strip_tags($this->host_updated));
        $this->host_hostType=htmlspecialchars(strip_tags($this->host_hostType));
        $this->host_ownedBy=htmlspecialchars(strip_tags($this->host_ownedBy));
        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_ramUsed=htmlspecialchars(strip_tags($this->host_ramUsed));
        $this->host_ramTotal=htmlspecialchars(strip_tags($this->host_ramTotal));
        $this->host_cpuUsed=htmlspecialchars(strip_tags($this->host_cpuUsed));
        $this->host_diskUsage=htmlspecialchars(strip_tags($this->host_diskUsage));
        $this->host_regStatus=htmlspecialchars(strip_tags($this->host_regStatus));
        $this->host_status=htmlspecialchars(strip_tags($this->host_status));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        $this->host_masterKey=htmlspecialchars(strip_tags($this->host_masterKey));


        // set values to object properties
        $this->host_ID = $row['ID'];
        $this->host_hostingStack = $row['HOSTING_STACK'];
        $this->host_os = $row['OS'];
        $this->host_site = $row['SITE'];
        $this->host_pubIP = $row['PUB_IP'];
        $this->host_appxLocation = $row['APPX_LOC'];
        $this->host_created = $row['CREATED'];
        $this->host_updated = $row['UPDATED'];
        $this->host_hostType = $row['HOST_TYPE'];
        $this->host_ownedBy = $row['OWNED_BY'];
        $this->host_hostUID = $row['HOST_UID'];
        $this->host_ramUsed = $row['RAM_USED'];
        $this->host_ramTotal = $row['RAM_TOTAL'];
        $this->host_cpuUsed = $row['CPU_USED'];
        $this->host_diskUsage = $row['DISK_USAGE'];
        $this->host_regStatus = $row['REG_STATUS'];
        $this->host_status = $row['STATUS'];
        $this->host_lastSeen = $row['LAST_SEEN'];

        //if ( $this->host_masterKey != "alpine" ) {
        //    $this->host_ID = "obfuscated";
        //}
        //var_dump($this->userID);
    }

    function countActiveStacksForUser() {
        $this->host_ownedBy=htmlspecialchars(strip_tags($this->host_ownedBy));

        $query = "
            SELECT COUNT(`ID`) AS 'C' 
            FROM " . $this->table_HOSTS . " 
            WHERE `OWNED_BY` = '" . $this->host_ownedBy . "' AND `REG_STATUS` = 'Registered';
        ";

        // prepare query statement
        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->host_ownedBy);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        $this->host_retCount=htmlspecialchars(strip_tags($this->host_retCount));
        $this->host_retCount = $row['C'];
    }

   // create Host
    function create(){
        // query to insert record
        //         ID, HOSTING_STACK, OS, SITE, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, LAST_SEEN

        $query = "INSERT INTO
                " . $this->table_HOSTS . "
                SET
                `" . "HOSTING_STACK" . "`= '". $this->host_hostingStack ."',
                `" . "OS" . "`= '". $this->host_os ."',
                `" . "SITE" . "`= '". $this->host_site ."',
                `" . "PUB_IP" . "`= '". $this->host_pubIP ."',
                `" . "APPX_LOC" . "`= '". $this->host_appxLocation ."',
                `" . "HOST_TYPE" . "`= '". $this->host_hostType ."',
                `" . "OWNED_BY" . "`= '". $this->host_ownedBy ."',
                `" . "HOST_UID" . "`= '". $this->host_hostUID ."',
            	`" . "LAST_SEEN" . "`= '". $this->host_lastSeen ."'
		;";


                   // UID=:UID";

        //podUID=:podUID, cpu_usage=:cpu_usage, cpu_temp=:cpu_temp, ram_usage=:ram_usage, hdd_usage=:hdd_usage, pod_temp=:pod_temp, pod_humidity=:pod_humidity

        // prepare query
        $stmt = $this->conn->prepare($query);
	   //var_dump($stmt);
        // sanitize
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));
        $this->host_os=htmlspecialchars(strip_tags($this->host_os));
        $this->host_site=htmlspecialchars(strip_tags($this->host_site));
        $this->host_pubIP=htmlspecialchars(strip_tags($this->host_pubIP));
        $this->host_appxLocation=htmlspecialchars(strip_tags($this->host_appxLocation));
        $this->host_hostType=htmlspecialchars(strip_tags($this->host_hostType));
        $this->host_ownedBy=htmlspecialchars(strip_tags($this->host_ownedBy));
        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        // bind values
        $stmt->bindParam(":HOSTING_STACK", $this->host_hostingStack);
        $stmt->bindParam(":OS", $this->host_os);
        $stmt->bindParam(":SITE", $this->host_site);
        $stmt->bindParam(":PUB_IP", $this->host_pubIP);
        $stmt->bindParam(":APPX_LOC", $this->host_appxLocation);
        $stmt->bindParam(":HOST_TYPE", $this->host_hostType);
        $stmt->bindParam(":OWNED_BY", $this->host_ownedBy);
        $stmt->bindParam(":HOST_UID", $this->host_hostUID);
        $stmt->bindParam(":LAST_SEEN", $this->host_lastSeen);

        //var_dump($this->uniqueKey);

        // execute query
        if($stmt->execute()){
            return true;
        }
        return false;
    }

    // From UID
    function editSystemStatus(){
        // sanitize
        //         ID, HOSTING_STACK, OS, SITE, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, LAST_SEEN

        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_ramUsed=htmlspecialchars(strip_tags($this->host_ramUsed));
        $this->host_ramTotal=htmlspecialchars(strip_tags($this->host_ramTotal));
        $this->host_cpuUsed=htmlspecialchars(strip_tags($this->host_cpuUsed));
        $this->host_diskUsage=htmlspecialchars(strip_tags($this->host_diskUsage));
        $this->host_status=htmlspecialchars(strip_tags($this->host_status));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_HOSTS . "
        SET
            `" . "RAM_USED" . "`= '". $this->host_ramUsed ."',
            `" . "RAM_TOTAL" . "`= '". $this->host_ramTotal ."',
            `" . "CPU_USED" . "`= '". $this->host_cpuUsed ."',
            `" . "DISK_USAGE" . "`= '". $this->host_diskUsage ."',
            `" . "STATUS" . "`= '". $this->host_status ."',
            `" . "LAST_SEEN" . "`= '". $this->host_lastSeen ."'
        WHERE
            `HOST_UID` = '" . $this->host_hostUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":RAM_USED", $this->host_ramUsed);
        $stmt->bindParam(":RAM_TOTAL", $this->host_ramTotal);
        $stmt->bindParam(":CPU_USED", $this->host_cpuUsed);
        $stmt->bindParam(":DISK_USAGE", $this->host_diskUsage);
        $stmt->bindParam(":STATUS", $this->host_status);
        $stmt->bindParam(":LAST_SEEN", $this->host_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }


    // From UID
    function editRegisteringState(){
        // sanitize
        //         ID, HOSTING_STACK, OS, SITE, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_regStatus=htmlspecialchars(strip_tags($this->host_regStatus));
        $this->host_status=htmlspecialchars(strip_tags($this->host_status));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_HOSTS . "
        SET
            `" . "REG_STATUS" . "`= '". $this->host_regStatus ."',
            `" . "STATUS" . "`= '". $this->host_status ."',
            `" . "LAST_SEEN" . "`= '". $this->host_lastSeen ."'
        WHERE
            `HOST_UID` = '" . $this->host_hostUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":REG_STATUS", $this->host_regStatus);
        $stmt->bindParam(":STATUS", $this->host_status);
        $stmt->bindParam(":LAST_SEEN", $this->host_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function editPubIP(){
        // sanitize
        //         ID, HOSTING_STACK, OS, SITE, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_pubIP=htmlspecialchars(strip_tags($this->host_pubIP));
        $this->host_appxLocation=htmlspecialchars(strip_tags($this->host_appxLocation));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_HOSTS . "
        SET
            `" . "PUB_IP" . "`= '". $this->host_pubIP ."',
            `" . "APPX_LOC" . "`= '". $this->host_appxLocation ."',
            `" . "LAST_SEEN" . "`= '". $this->host_lastSeen ."'
        WHERE
            `HOST_UID` = '" . $this->host_hostUID . "'
        ;";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":PUB_IP", $this->host_pubIP);
        $stmt->bindParam(":APPX_LOC", $this->host_appxLocation);
        $stmt->bindParam(":LAST_SEEN", $this->host_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function bindStackToHost(){
        // sanitize
        //         ID, HOSTING_STACK, OS, SITE, CREATED, UPDATED, HOST_TYPE, OWNED_BY, HOST_UID, RAM_USED, RAM_TOTAL, CPU_USED, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->host_hostUID=htmlspecialchars(strip_tags($this->host_hostUID));
        $this->host_hostingStack=htmlspecialchars(strip_tags($this->host_hostingStack));
        $this->host_lastSeen=htmlspecialchars(strip_tags($this->host_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_HOSTS . "
        SET
            `" . "HOSTING_STACK" . "`= '". $this->host_hostingStack ."',
            `" . "REG_STATUS" . "`= 'Registering',
            `" . "STATUS" . "`= 'Busy',
            `" . "LAST_SEEN" . "`= '". $this->host_lastSeen ."'            
        WHERE
            `HOST_UID` = '" . $this->host_hostUID . "'
        ;";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);
        //echo "query = " . $query;

        // bind values
        $stmt->bindParam(":HOSTING_STACK", $this->host_hostingStack);
        $stmt->bindParam(":HOST_UID", $this->host_hostUID);
        $stmt->bindParam(":LAST_SEEN", $this->host_lastSeen);
        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }



    // used when filling up the update product form
/*    function readLast(){
        $query = "
        SELECT actionID, targetPodUID, timestamp, targetRelayID, askedByClient, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_HOSTS . "
        WHERE `targetPodUID` = '" . $this->targetPodUID . "' AND `actionStatus` = '" . "submitted" . "'
        ORDER BY actionID ASC LIMIT 0,1";
        //AND `askedByClient` = '" . $this->askedByClient . "'

        //var_dump($query);

        // prepare query statement
        $stmt = $this->conn->prepare( $query );

        // bind id of product to be updated
        $stmt->bindParam(1, $this->targetPodUID);

        // execute query
        $stmt->execute();

        // get retrieved row
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        $this->actionID=htmlspecialchars(strip_tags($this->actionID));
        $this->targetPodUID=htmlspecialchars(strip_tags($this->targetPodUID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->targetRelayID=htmlspecialchars(strip_tags($this->targetRelayID));
        $this->askedByClient=htmlspecialchars(strip_tags($this->askedByClient));
        $this->action=htmlspecialchars(strip_tags($this->action));
        $this->actionStatus=htmlspecialchars(strip_tags($this->actionStatus));
        $this->acknoledgedTT=htmlspecialchars(strip_tags($this->acknoledgedTT));
        $this->startedTT=htmlspecialchars(strip_tags($this->startedTT));
        $this->doneTT=htmlspecialchars(strip_tags($this->doneTT));

        // set values to object properties
        $this->actionID = $row['actionID'];
        $this->targetPodUID = $row['targetPodUID'];
        $this->timestamp = $row['timestamp'];
        $this->targetRelayID = $row['targetRelayID'];
        $this->askedByClient = $row['askedByClient'];
        $this->action = $row['action'];
        $this->actionStatus = $row['actionStatus'];
        $this->acknoledgedTT = $row['acknoledgedTT'];
        $this->startedTT = $row['startedTT'];
        $this->doneTT = $row['doneTT'];
    }

    function editSystemInfo(){
        // sanitize
        $this->systemInfoID=htmlspecialchars(strip_tags($this->systemInfoID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->podUID=htmlspecialchars(strip_tags($this->podUID));
        $this->cpu_usage=htmlspecialchars(strip_tags($this->cpu_usage));
        $this->cpu_temp=htmlspecialchars(strip_tags($this->cpu_temp));
        $this->ram_usage=htmlspecialchars(strip_tags($this->ram_usage));
        $this->hdd_usage=htmlspecialchars(strip_tags($this->hdd_usage));
        $this->pod_temp=htmlspecialchars(strip_tags($this->pod_temp));
        $this->pod_humidity=htmlspecialchars(strip_tags($this->pod_humidity));

        // update query
        $query = "UPDATE
            " . $this->table_HOSTS . "
        SET
            `" . "timestamp" . "`= '". $this->timestamp ."',
            `" . "cpu_usage" . "`= '". $this->cpu_usage ."',
            `" . "cpu_temp" . "`= '". $this->cpu_temp ."',
            `" . "ram_usage" . "`= '". $this->ram_usage ."',
            `" . "hdd_usage" . "`= '". $this->hdd_usage ."',
            `" . "pod_temp" . "`= '". $this->pod_temp ."',
            `" . "pod_humidity" . "`= '". $this->pod_humidity ."'
        WHERE
            `podUID` = '" . $this->podUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":cpu_usage", $this->cpu_usage);
        $stmt->bindParam(":cpu_temp", $this->cpu_temp);
        $stmt->bindParam(":ram_usage", $this->ram_usage);
        $stmt->bindParam(":hdd_usage", $this->hdd_usage);
        $stmt->bindParam(":pod_temp", $this->pod_temp);
        $stmt->bindParam(":pod_humidity", $this->pod_humidity);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }*/
}

?>
