<?php
class services{

    // database connection and table clientKey
    private $conn;
    private $table_SVCIDS = "T_SVCIDS";

    // object properties
    public $serviceID;
    public $created;
    public $updated;
    public $serviceName;
    public $isActive;
    public $masterKey;

    // constructor with $db as database connection
    public function __construct($db){
        $this->conn = $db;
    }

    // read products
/*    function read(){
        $query = "
        SELECT actionID, timestamp, askedByClient, targetPodUID, targetRelayID, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_SVCIDS . "
        GROUP BY targetPodUID
        ORDER BY timestamp DESC";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        // execute query
        $stmt->execute();

        return $stmt;
    }
*/

    function readOne() {
        // Trigram Key is obfuscated
        $query = "
        SELECT ID, CREATED, UPDATED, SVC_NAME, IS_ACTIVE
        FROM
        " . $this->table_SVCIDS . "
        WHERE `ID` = '" . $this->serviceID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        // prepare query statement
        $stmt = $this->conn->prepare( $query );

        // bind id of product to be updated
        $stmt->bindParam(1, $this->serviceID);

        // execute query
        $stmt->execute();

        // get retrieved row
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        //var_dump($row);

        $this->serviceID=htmlspecialchars(strip_tags($this->serviceID));
        $this->created=htmlspecialchars(strip_tags($this->created));
        $this->updated=htmlspecialchars(strip_tags($this->updated));
        $this->serviceName=htmlspecialchars(strip_tags($this->serviceName));
        $this->isActive=htmlspecialchars(strip_tags($this->isActive));

        $this->masterKey=htmlspecialchars(strip_tags($this->masterKey));


        // set values to object properties
        $this->serviceID = $row['ID'];
        $this->created = $row['CREATED'];
        $this->updated = $row['UPDATED'];
        $this->serviceName = $row['SVC_NAME'];
        $this->isActive = $row['IS_ACTIVE'];

        if ( $this->masterKey != "alpine" ) {
            $this->trigramKey = "obfuscated";
        }
        //var_dump($this->userID);
    }

   // create product
    function create(){
        // query to insert record
        $query = "INSERT INTO
                    " . $this->table_SVCIDS . "
                SET
	          	`" . "UID" . "`= '". $this->uniqueKey ."',
            		`" . "REQ_BY" . "`= '". $this->reqBy ."'
		";


                   // UID=:UID";

        //podUID=:podUID, cpu_usage=:cpu_usage, cpu_temp=:cpu_temp, ram_usage=:ram_usage, hdd_usage=:hdd_usage, pod_temp=:pod_temp, pod_humidity=:pod_humidity

        // prepare query
        $stmt = $this->conn->prepare($query);

	//var_dump($stmt);

        // sanitize
        $this->uniqueKey=htmlspecialchars(strip_tags($this->uniqueKey));
        $this->uniqueKey=htmlspecialchars(strip_tags($this->reqBy));

        // bind values
        $stmt->bindParam(":UID", $this->uniqueKey);
        $stmt->bindParam(":REQ_BY", $this->reqBy);

        //var_dump($this->uniqueKey);

        // execute query
        if($stmt->execute()){
            return true;
        }
        return false;

    }

    // used when filling up the update product form
/*    function readLast(){
        $query = "
        SELECT actionID, targetPodUID, timestamp, targetRelayID, askedByClient, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_SVCIDS . "
        WHERE `targetPodUID` = '" . $this->targetPodUID . "' AND `actionStatus` = '" . "submitted" . "'
        ORDER BY actionID ASC LIMIT 0,1";
        //AND `askedByClient` = '" . $this->askedByClient . "'

        //var_dump($query);

        // prepare query statement
        $stmt = $this->conn->prepare( $query );

        // bind id of product to be updated
        $stmt->bindParam(1, $this->targetPodUID);

        // execute query
        $stmt->execute();

        // get retrieved row
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        $this->actionID=htmlspecialchars(strip_tags($this->actionID));
        $this->targetPodUID=htmlspecialchars(strip_tags($this->targetPodUID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->targetRelayID=htmlspecialchars(strip_tags($this->targetRelayID));
        $this->askedByClient=htmlspecialchars(strip_tags($this->askedByClient));
        $this->action=htmlspecialchars(strip_tags($this->action));
        $this->actionStatus=htmlspecialchars(strip_tags($this->actionStatus));
        $this->acknoledgedTT=htmlspecialchars(strip_tags($this->acknoledgedTT));
        $this->startedTT=htmlspecialchars(strip_tags($this->startedTT));
        $this->doneTT=htmlspecialchars(strip_tags($this->doneTT));

        // set values to object properties
        $this->actionID = $row['actionID'];
        $this->targetPodUID = $row['targetPodUID'];
        $this->timestamp = $row['timestamp'];
        $this->targetRelayID = $row['targetRelayID'];
        $this->askedByClient = $row['askedByClient'];
        $this->action = $row['action'];
        $this->actionStatus = $row['actionStatus'];
        $this->acknoledgedTT = $row['acknoledgedTT'];
        $this->startedTT = $row['startedTT'];
        $this->doneTT = $row['doneTT'];
    }

    function editSystemInfo(){
        // sanitize
        $this->systemInfoID=htmlspecialchars(strip_tags($this->systemInfoID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->podUID=htmlspecialchars(strip_tags($this->podUID));
        $this->cpu_usage=htmlspecialchars(strip_tags($this->cpu_usage));
        $this->cpu_temp=htmlspecialchars(strip_tags($this->cpu_temp));
        $this->ram_usage=htmlspecialchars(strip_tags($this->ram_usage));
        $this->hdd_usage=htmlspecialchars(strip_tags($this->hdd_usage));
        $this->pod_temp=htmlspecialchars(strip_tags($this->pod_temp));
        $this->pod_humidity=htmlspecialchars(strip_tags($this->pod_humidity));

        // update query
        $query = "UPDATE
            " . $this->table_SVCIDS . "
        SET
            `" . "timestamp" . "`= '". $this->timestamp ."',
            `" . "cpu_usage" . "`= '". $this->cpu_usage ."',
            `" . "cpu_temp" . "`= '". $this->cpu_temp ."',
            `" . "ram_usage" . "`= '". $this->ram_usage ."',
            `" . "hdd_usage" . "`= '". $this->hdd_usage ."',
            `" . "pod_temp" . "`= '". $this->pod_temp ."',
            `" . "pod_humidity" . "`= '". $this->pod_humidity ."'
        WHERE
            `podUID` = '" . $this->podUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":cpu_usage", $this->cpu_usage);
        $stmt->bindParam(":cpu_temp", $this->cpu_temp);
        $stmt->bindParam(":ram_usage", $this->ram_usage);
        $stmt->bindParam(":hdd_usage", $this->hdd_usage);
        $stmt->bindParam(":pod_temp", $this->pod_temp);
        $stmt->bindParam(":pod_humidity", $this->pod_humidity);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }*/
}

?>
