<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../../config/database_multiplicity.php';

// instantiate uids object
include_once '../../objects/uids.php';
include_once '../../objects/users.php';
include_once '../../objects/hosts.php';
include_once '../../objects/stacks.php';
include_once '../../objects/stack_dc.php';
include_once '../../objects/services.php';
include_once '../../objects/apikeys.php';
include_once '../../objects/apilogs.php';

include_once '../../lib/apiServices.php';

$api_Service = 'dc-register';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);        // UniqID
$hosts = new hosts($db);      // Hosts 
$stacks = new stacks($db);      // Hosts 
$stack_dc = new stack_dc($db);      // Hosts 
$apiKeys = new apiKeys($db);  // apis
$users = new users($db);      // Users
$services = new services($db);  
$apiLogs = new apiLogs($db);

// get posted data
//$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  elseif ($type == 'POST') { echo '{', PHP_EOL, '"message": "Mendatroy variable missing : ' . $paramName . '."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function dieAfterCallbackError($param) {
  echo '{', PHP_EOL, '"error": could not retieve an ID!" --> ' . $param . '."', PHP_EOL, '}';
  die(); 
}

// That's when you have an API Key doh ! :D (from webby we dont have one :D)
function getUniqueID($apiKey) {
  $opts = [
    "http" => [
        "method" => "GET",
        "header" => "Accept-language: en\r\n" .
        "x-auth-apiKey: " . $apiKey . "\r\n"
    ]
  ];

  $context = stream_context_create($opts);
  $resp_getUniqueID = file_get_contents('http://127.0.0.1/ws/getUniqId.php?len=32', false, $context);
  $resp_getUniqueID = isset($resp_getUniqueID) ? $resp_getUniqueID : dieAfterCallbackError($resp_getUniqueID);

  $resp_getUniqueID = json_decode($resp_getUniqueID);

  return $resp_getUniqueID; // $resp_getUniqueID->UID needed to fecth the UID
}

function getGenericApiKey($apiKey) {
  $opts = [
    "http" => [
        "method" => "GET",
        "header" => "Accept-language: en\r\n" .
        "x-auth-apiKey: " . $apiKey . "\r\n"
    ]
  ];

  $context = stream_context_create($opts);
  $resp_gak = file_get_contents('http://127.0.0.1/ws/generateAPIKey.php?type=node', false, $context);
  $resp_gak = isset($resp_gak) ? $resp_gak : dieAfterCallbackError($resp_gak);

  $resp_gak = json_decode($resp_gak);

  return $resp_gak; // $resp_getUniqueID->UID needed to fecth the UID
}

function validateParametters($param, $valid_options) {
  $param = trim(strtolower($param), ' ');
  $valid_options_arr = explode(',', $valid_options);

  foreach ($valid_options_arr as $key => $valid_option) {
    $valid_option = trim($valid_option, ' ');

    switch ($valid_option) {
      case '0.0.0.0':
        // IP --> Check if we have an IP /// , FILTER_FLAG_IPV4
        if (filter_var($param, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
          return true;
        }
        break;
      
      case 'TRG':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 3) {
          if (ctype_alpha($param)) {
            return true;
          }
        }
        break;

      case 'len32':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 32) {
          if (ctype_alnum($param)) {
            return true;
          }
        }
        break;

      case 'len64':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 64) {
          if (ctype_alnum($param)) {
            return true;
          }
        }
        break;
      
      case '':
        // Void
        return true;
        break;

      default:
        // param == validparam
        if ($param == $valid_option) {
          return true;
        }
        break;
    }
  }

  return false;
}

/* DC : Register
** Analyze POST
** Stack UID (Hosted Within)
** DC UID : To Gen !
** GEN API Key : Generic API Key to use
** Last seen : 0000
*/ 

// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // STEP 1 
  // Fetch API Key & Validate
  foreach (getallheaders() as $name => $value) {
    if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
  }
  isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

  $validateApiBlob = validateApiKey($uids->reqBy);


  // STEP 2
  // Validate Params
  $post_params = array(
    "stackUID" => isset($_POST['stackUID']) ? $_POST['stackUID'] : dieAfterNotif('stackUID', 'POST')
  );

  $accepted_values = array(
    "stackUID" => "len32, len64"
  );

  foreach ($post_params as $post_key => $post_param) {
    if (validateParametters($post_param, $accepted_values[$post_key]) == false) {
      // Display helper
      echo '{', PHP_EOL, '"message": "Helper: \'' . $post_param . '\' is not contained within allowed parameters : \'' . $accepted_values[$post_key] . '\' ."', PHP_EOL, '}';
      die();
    }
  }


  // STEP 3
  // Retrieve Stack ID from UID
  $stacks->stacks_UID = $post_params['stackUID'];
  $stacks->readOneFromUID();
  $stack_arr = array (
    "ID" => $stacks->stacks_ID,
    "NAME" => $stacks->stacks_name,
    "CREATED" => $stacks->stacks_created,
    "UPDATED" => $stacks->stacks_updated,
    "STACK_UID" => $stacks->stacks_UID,
    "HOSTED_ON" => $stacks->stacks_hostedOn,
    "HOSTING_DC" => $stacks->stacks_hostingDC,
    "NB_STACK_VM" => $stacks->stacks_nbStackVM,
    "NB_STACK_VM_ON" => $stacks->stacks_nbStackVMOn,
    "NB_VMS_ONLINE" => $stacks->stacks_nbVMOnline,
    "NB_VMS_AVAIL" => $stacks->stacks_nbVMAvail,
    "REG_STATUS" => $stacks->stacks_regStatus,
    "STATUS" => $stacks->stacks_status,
    "PROV_STATUS" => $stacks->stacks_provStatus,
    "PROV_JOB_STATUS" => $stacks->stacks_provJobStatus,
    "PROV_JOB_PENDING" => $stacks->stacks_provJobPending,
    "PROV_JOB_RUNNING" => $stacks->stacks_provJobRunning,
    "LAST_SEEN" => $stacks->stacks_lastSeen
  );

  if (is_null($stack_arr['ID'])) {
    echo '{', PHP_EOL, '"error": "Stack UID provided (' . $post_params['stackUID'] . ') does not matches with any known Stack!"', PHP_EOL, '}';
    die();
  }

  // Make there is no DC with that Stack ID already !
  if (is_null($stack_arr['HOSTING_DC']) == false) {
    echo '{', PHP_EOL, '"error": "Stack (' . $post_params['stackUID'] . ') already hosts a DC! - aborting."', PHP_EOL, '}';    
    die();
  }

  // Make sure there is not a DC with the HostedOn/StackUID we're trying to use !
  $stack_dc->stackDC_hostedOn=$stack_arr['ID'];
  $stack_dc->readOneFromHostedOnID();

  if (is_null($stack_dc->stackDC_ID) == false) {
    echo '{', PHP_EOL, '"error": "Target stack (' . $post_params['stackUID'] . ') is already binded with another DC - aborting. "', PHP_EOL, '}';
    die();
  }

  // STEP 4
  // Get DC UID
  $guid_dc_resp = getUniqueID($uids->reqBy);
  $uid_dc_raw = $guid_dc_resp->UID;
  $uid_dc_reqBy = $guid_dc_resp->REQ_BY_NAME;

  // STEP 5
  // GAK : Gen-api-key
  $gak_dc_resp = getGenericApiKey($uids->reqBy);
  if (isset($gak_dc_resp->api_key)) {
    $api_dc_raw = $gak_dc_resp->api_key;
  } else {
    echo '{', PHP_EOL, '"error": "An error occured while creating GEN API : \'' . $gak_dc_resp->error . '\' - aborting."', PHP_EOL, '}';    
    die();
  }

  // STEP 6
  // Create DC Enveloppe
  // --> Hosted On : Stack ID
  // --> Stack DC UID : DC UID
  // --> Gen API Key : Api Key Freshly acquired
  $stack_dc->stackDC_hostedOn=$stack_arr['ID'];
  $stack_dc->stackDC_UID=$uid_dc_raw;
  $stack_dc->stackDC_genAPIKey=$gak_dc_resp->api_key;
  $stack_dc->stackDC_lastSeen='0000-00-00 00:00:00';

  if ($stack_dc->create()) {
    $message = 'Stack_DC enveloppe successfully created.';
    $error = false;
  } else {
    $message='Something went wrong while creating Stack_DC envelop.';
    $error = true;
  }

  $stack_dc_arr = array(
    "message" => $message,
    "error" => $error,
    //"hosts_count" => $host_count,
    "STACK_DC_UID" => $uid_dc_raw,
    "HOSTED_ON_UID" => $post_params['stackUID'],
    "GEN_API_KEY" => $gak_dc_resp->api_key,
    "LAST_SEEN" => $stacks->stacks_lastSeen
  );

  print_r(json_encode($stack_dc_arr));

} else {
  echo '{', PHP_EOL, '"error": "Request method : ' . $_SERVER['REQUEST_METHOD'] . ' not allowed."', PHP_EOL, '}';
  die();
}


die();






/*


************************ INSPI BLOC



*/













// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // The request is using the POST method


  //var_dump($_POST);
  // Fetch Options
  //$opt_site = isset($_POST['type']) ? $_POST['type'] : $type = '';

  $post_params = array(
    "site" => isset($_POST['site']) ? $_POST['site'] : dieAfterNotif('site', 'POST'),
    "pub" => isset($_POST['pub']) ? $_POST['pub'] : dieAfterNotif('pub', 'POST'),
    "appx" => isset($_POST['appx']) ? $_POST['appx'] : dieAfterNotif('appx', 'POST'),
    "htype" => isset($_POST['htype']) ? $_POST['htype'] : dieAfterNotif('htype', 'POST'),
    "owner" => isset($_POST['owner']) ? $_POST['owner'] : dieAfterNotif('owner', 'POST'),
    "os" => isset($_POST['os']) ? $_POST['os'] : dieAfterNotif('os', 'POST'),
  );

  $accepted_values = array(
    "site" => "delta, laptop, TRG",
    "pub" => "0.0.0.0",
    "appx" => "",
    "htype" => "mutu, perso",
    "owner" => 'ddbuiq, TRG',
    "os" => "osx, win10, deb10, deb11, deb12, esxi"
  );

  // STEP 1
  // Looking for apiKey:secret in headers.
  foreach (getallheaders() as $name => $value) {
    if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
  }
  isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

  // STEP 2
  // Validate key
  $validateApiBlob = validateApiKey($uids->reqBy);

  // STEP 3
  // Validate params : Helper accepted, we're auth'd
  foreach ($post_params as $post_key => $post_param) {
    if (validateParametters($post_param, $accepted_values[$post_key]) == false) {
      // Display helper
      echo '{', PHP_EOL, '"message": "Helper: \'' . $post_param . '\' is not contained within allowed parameters : \'' . $accepted_values[$post_key] . '\' ."', PHP_EOL, '}';
      die();
    }
  }

  // STEP 4
  // Get UID to create Host
  $guid_host_resp = getUniqueID($uids->reqBy);
  $uid_host_raw = $guid_host_resp->UID;
  $uid_host_reqBy = $guid_host_resp->REQ_BY_NAME;

  //print_r($post_params);
  //print_r($validateApiBlob);
  //print_r($guid_resp);

  // STEP 5
  // Check if user don't exceed maximum allowed hosts
  $hosts->host_ownedBy = $post_params['owner'];
  $hosts->countActiveStacksForUser();
  $host_count=$hosts->host_retCount;
  //var_dump($hosts->host_retCount);

  if ($host_count >= $maximumStacksAllowedPerUser) {
    // Maximum Stack for user exceeded
    echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
    die();
  }

  // STEP 6
  // Create Host envelop
  $hosts->host_hostingStack=0;
  $hosts->host_os=$post_params['os'];
  $hosts->host_site=$post_params['site'];
  $hosts->host_pubIP=$post_params['pub'];
  $hosts->host_appxLocation=$post_params['appx'];
  $hosts->host_hostType=$post_params['htype'];
  $hosts->host_ownedBy=$post_params['owner'];
  $hosts->host_hostUID=$uid_host_raw;
  $hosts->host_lastSeen='0000-00-00 00:00:00';

  if ($hosts->create()) {
    $message = 'Host envelop successfully created.';
    $error = false;
  } else {
    $message='Something went wrong while creating host envelop.';
    $error = true;
  }

  $host_arr = array(
    "message" => $message,
    "error" => $error,
    "hosts_count" => $host_count,
    "OS" => $hosts->host_os,
    "SITE" => $hosts->host_site,
    "PUB_IP" => $hosts->host_pubIP,
    "LOC_APPX" => $hosts->host_appxLocation,
    "HOST_TYPE" => $hosts->host_hostType,
    "OWNED_BY" => $hosts->host_ownedBy,
    "HOST_UID" => $hosts->host_hostUID,
    "HOSTING_STACK" => $hosts->host_hostingStack,
    "LAST_SEEN" => $hosts->host_lastSeen
  );

  print_r(json_encode($host_arr));

} else {
  echo '{', PHP_EOL, '"error": "Request method : ' . $_SERVER['REQUEST_METHOD'] . ' not allowed."', PHP_EOL, '}';
  die();
}


die();


// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


// Fetch Options
$type = isset($_GET['type']) ? $_GET['type'] : $type = '';

// STEP 1
// Looking for apiKey:secret in headers.
foreach (getallheaders() as $name => $value) {
  if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
}
isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

// SETP 2
// Validate key
$validateApiBlob = validateApiKey($uids->reqBy);

// STEP 3
// Get UID to generate a key
$resp = getUniqueID($uids->reqBy);
$uid_raw = $resp->UID;
$reqByName = $resp->REQ_BY_NAME;

// STEP 4
// Validate there is no weird stuff (reqByName == tmpReqByName)

$isUser = false;
$isService = false;
$identity_arr = $validateApiBlob['IDENTITY'];

if (array_key_exists('SVC_NAME', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 0) {
  // Service
  $isService = true;
} elseif (array_key_exists('TRIGRAM_KEY', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 1) {
  // User
  $isUser = true;
} else {
  // Not found
  echo '{', PHP_EOL, '"error": "could not find matching entries within identity array!"', PHP_EOL, '}';
  die();
}

$tmpReqByName = $validateApiBlob['REQBY'];
$__generateFakeKey = false;

//print_r($validateApiBlob);
//print_r($resp);

if ($tmpReqByName == $reqByName) {
  if ($isUser == true) {
    // is user :

    if ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-web-auth-token') {
      // DESC =  generic-web-auth-token --> He has no API Key (from web)

      $apiKeys->reqBy = $reqByName;
      $apiKeys->countActiveStackApiForUser();

      // Check if we're not exceding maximum allowed simultaneous keys.
      if ($apiKeys->retCount < $maximumStacksAllowedPerUser) {
        // TODO //
        // Faire la même pour les HR en ligne (dans la table HR)

        $__registeredStacks = 0;

        if ($__registeredStacks < $maximumStacksAllowedPerUser) {
          switch ($type) {
            case 'stack_key':
              $apiPrefix = 'stack_key-' . $reqByName . '-';
              $apiDesc = 'generic-stack-singleuse-token';
              break;
            
            case 'apikey':
              $apiPrefix = 'apikey-' . $reqByName . '-';
              $apiDesc = 'user-querry-apikey';
              break;
              
            default:
              $apiPrefix = 'fake_key-' . $reqByName . '-';
              $__generateFakeKey = true;
              break;
          }

        } else {
          echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
          die();
        }
        
      } else {
        echo '{', PHP_EOL, '"error": "maximum amount of stack_api generated for this account."', PHP_EOL, '}';
        die();
      }



    } elseif ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-stack-singleuse-token') {
      // DESC = generic-stack-singleuse-token --> Needs a generic api : HR API & DC API
      // host --> DESC : generic-stack-hostrunner-token
      // node --> DESC : generic-stack-noderunner-token

      switch ($type) {
        case 'host':
          $apiPrefix = 'generic-stack-hr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-hostrunner-token';
          break;
        
        case 'node':
          $apiPrefix = 'generic-stack-nr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-noderunner-token';
          break;
        
        default:
          $apiPrefix = 'fake_key-' . $reqByName . '-';
          $__generateFakeKey = true;
          break;
      }

    } else {
      // Can be a user key ? But a user key cannot generate further API :)
      die();
    }

  } elseif ($isUser == false) {
    // Service : 
    $apiPrefix = 'svckey' . $reqByName;
  } else {
    die();
  }
} else {
  die();
}

$generatedAPIKey = $apiPrefix . $uid_raw;
$generatedAPIKeyStatus = false;

// bouchon a delete
//$__generateFakeKey = true;

if ($__generateFakeKey == false) {
  // Generate API

  $apiKeys->description = $apiDesc;
  $apiKeys->apiKey = $generatedAPIKey;
  $apiKeys->isUser = $isUser;
  $apiKeys->foreignID = $validateApiBlob['APIKEY']['FOREIGN_ID'];
  $apiKeys->isActive = $validateApiBlob['APIKEY']['IS_ACTIVE'];

  $generatedAPIKeyStatus = $apiKeys->create();

  if ($generatedAPIKeyStatus === true) {
    $message = 'apiKey successfully created!';
  } else {
    $message = 'something went terribly wrong...';    
  }
} else {
  $message = 'good job captain...!';    
}

$jsonOutput = array(
  "message" => $message,
  "timestamp" => date('Y-m-d H:i:s'),
  "api_key" => $generatedAPIKey,
  "numberOfRecords" => $apiKeys->retCount,
  "isCreated" => $generatedAPIKeyStatus,
  "isBambooz" => $__generateFakeKey
);

#  "numberOfRecords" => $apiKeys->countActiveStackApiForUser(),

print_r(json_encode($jsonOutput));


//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
//$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

## Global
$apiKeys->timestamp = date('Y-m-d H:i:s');

?>
