<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../config/database_multiplicity.php';

// instantiate uids object
include_once '../objects/uids.php';
include_once '../objects/users.php';
include_once '../objects/services.php';
include_once '../objects/apikeys.php';
include_once '../objects/apilogs.php';

include_once '../lib/apiServices.php';

$api_Service = 'generateAPIKey';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);
$apiKeys = new apiKeys($db);
$users = new users($db);
$services = new services($db);
$apiLogs = new apiLogs($db);

// get posted data
$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function dieAfterCallbackError($param) {
  echo '{', PHP_EOL, '"error": could not retieve an ID!" --> ' . $param . '."', PHP_EOL, '}';
  die(); 
}

// That's when you have an API Key doh ! :D (from webby we dont have one :D)
function getUniqueID($apiKey) {
  $opts = [
    "http" => [
        "method" => "GET",
        "header" => "Accept-language: en\r\n" .
        "x-auth-apiKey: " . $apiKey . "\r\n"
    ]
  ];

  $context = stream_context_create($opts);
  $resp_getUniqueID = file_get_contents('http://127.0.0.1/ws/getUniqId.php?len=32', false, $context);
  $resp_getUniqueID = isset($resp_getUniqueID) ? $resp_getUniqueID : dieAfterCallbackError($resp_getUniqueID);

  //print_r($resp_getUniqueID);
  //die();
  //$lintedResult = explode('{', $resp_getUniqueID);
  //$resp_getUniqueID = '{' . $lintedResult[2];
  $resp_getUniqueID = json_decode($resp_getUniqueID);

  return $resp_getUniqueID; // $resp_getUniqueID->UID needed to fecth the UID
}

// API Key
## Format : [gen dans l'interface] apikey-vlu-kjhuiqhwhq98sjbas8712bd | [gen pour genAPI] genapi-stack-vlu-kjqhwidhqhdkjasd8912
## Params
## User, Service (needed to create API)
## Authentify User ?
## Lengh of hash
## isGenApiKey ? : no -> apikey, yes -> genapi
## 
## Generation dans l'interface : 
## Request API --> UserID ==> apikey-vlu-qhjkwejkqkhjwe
## 
## Generation d'une Gen API (from an API Key OF apikey-vlu-qhjkwejkqkhjwe [Interface])
## Request Gen API --> API Key (Not a SVC) ==> genapi-stack-vlu-kjqhwidhqhdkjasd8912

// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


// Fetch Options
$type = isset($_GET['type']) ? $_GET['type'] : $type = '';

// STEP 1
// Looking for apiKey:secret in headers.
foreach (getallheaders() as $name => $value) {
  if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
}
isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

// SETP 2
// Validate key
$validateApiBlob = validateApiKey($uids->reqBy);

// STEP 3
// Get UID to generate a key
$resp = getUniqueID($uids->reqBy);
$uid_raw = $resp->UID;
$reqByName = $resp->REQ_BY_NAME;

// STEP 4
// Validate there is no weird stuff (reqByName == tmpReqByName)

$isUser = false;
$isService = false;
$identity_arr = $validateApiBlob['IDENTITY'];

if (array_key_exists('SVC_NAME', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 0) {
  // Service
  $isService = true;
} elseif (array_key_exists('TRIGRAM_KEY', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 1) {
  // User
  $isUser = true;
} else {
  // Not found
  echo '{', PHP_EOL, '"error": "could not find matching entries within identity array!"', PHP_EOL, '}';
  die();
}

$tmpReqByName = $validateApiBlob['REQBY'];
$__generateFakeKey = false;

//print_r($validateApiBlob);
//print_r($resp);

if ($tmpReqByName == $reqByName) {
  $reqByName = strtolower($reqByName);

  if ($isUser == true) {
    // is user :

    if ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-web-auth-token') {
      // DESC =  generic-web-auth-token --> He has no API Key (from web)

      $apiKeys->reqBy = $reqByName;
      $apiKeys->countActiveStackApiForUser();

      // Check if we're not exceding maximum allowed simultaneous keys.
      if ($apiKeys->retCount < $maximumStacksAllowedPerUser) {
        // TODO //
        // Faire la même pour les HR en ligne (dans la table HR)

        $__registeredStacks = 0;

        if ($__registeredStacks < $maximumStacksAllowedPerUser) {
          switch ($type) {
            case 'stack_key':
              $apiPrefix = 'stack_key-' . $reqByName . '-';
              $apiDesc = 'generic-stack-singleuse-token';
              break;
            
            case 'apikey':
              $apiPrefix = 'apikey-' . $reqByName . '-';
              $apiDesc = 'user-querry-apikey';
              break;

            default:
              $apiPrefix = 'fake_key-' . $reqByName . '-';
              $__generateFakeKey = true;
              break;
          }

        } else {
          echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
          die();
        }
        
      } else {
        echo '{', PHP_EOL, '"error": "maximum amount of stack_api generated for this account."', PHP_EOL, '}';
        die();
      }

    } elseif ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-stack-singleuse-token') {
      // DESC = generic-stack-singleuse-token --> Needs a generic api : HR API & DC API
      // host --> DESC : generic-stack-hostrunner-token
      // node --> DESC : generic-stack-noderunner-token

      switch ($type) {
        case 'host':
          $apiPrefix = 'generic-stack-hr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-hostrunner-token';
          break;
        
        case 'node':
          $apiPrefix = 'generic-stack-nr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-noderunner-token';
          break;
        
        default:
          $apiPrefix = 'fake_key-' . $reqByName . '-';
          $__generateFakeKey = true;
          break;
      }

    } else {
      // Can be a user key ? But a user key cannot generate further API :)
      die();
    }

  } elseif ($isUser == false) {
    // Service : 
    $apiPrefix = 'svckey' . $reqByName;
    //$apiDesc = 'generic-svc-token';
  } else {
    die();
  }
} else {
  die();
}

$generatedAPIKey = $apiPrefix . $uid_raw;
$generatedAPIKeyStatus = false;

// bouchon a delete
//$__generateFakeKey = true;

if ($__generateFakeKey == false) {
  // Generate API

  $apiKeys->description = $apiDesc;
  $apiKeys->apiKey = $generatedAPIKey;
  $apiKeys->isUser = $isUser;
  $apiKeys->foreignID = $validateApiBlob['APIKEY']['FOREIGN_ID'];
  $apiKeys->isActive = $validateApiBlob['APIKEY']['IS_ACTIVE'];

  $generatedAPIKeyStatus = $apiKeys->create();

  if ($generatedAPIKeyStatus === true) {
    $message = 'apiKey successfully created!';
  } else {
    $message = 'something went terribly wrong...';    
  }
} else {
  $message = 'good job captain...!';    
}

$jsonOutput = array(
  "message" => $message,
  "timestamp" => date('Y-m-d H:i:s'),
  "api_key" => $generatedAPIKey,
  "numberOfRecords" => $apiKeys->retCount,
  "isCreated" => $generatedAPIKeyStatus,
  "isBambooz" => $__generateFakeKey
);

#  "numberOfRecords" => $apiKeys->countActiveStackApiForUser(),

print_r(json_encode($jsonOutput));


//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
//$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

## Global
$apiKeys->timestamp = date('Y-m-d H:i:s');

?>
