<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../config/database_multiplicity.php';

// instantiate uids object
include_once '../objects/uids.php';
include_once '../objects/users.php';
include_once '../objects/services.php';
include_once '../objects/apikeys.php';
include_once '../objects/apilogs.php';

include_once '../lib/apiServices.php';

$api_Service = 'getUniqId';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);
$apiKeys = new apiKeys($db);
$users = new users($db);
$services = new services($db);
$apiLogs = new apiLogs($db);

// get posted data
$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function writeAPILog($apiLogs, $__apiKey, $__apiService, $__success, $__log) {
  $apiLogs->reqBy = $__apiKey;
  $apiLogs->service = $__apiService;
  $apiLogs->isSuccess = $__success;
  $apiLogs->apiLog = $__log;

  $apiLogs->create(); 
}

//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;


// Looking for apiKey:secret in headers.
foreach (getallheaders() as $name => $value) {
  if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
}
isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

//if ($_SERVER['REQUEST_METHOD'] === 'POST') {
//     // The request is using the POST method
//} else {
//  die();
//}

// API Validator
// Check if API Key is valid & Active
// Check if we have a User Key or Service Key
// Check is the SVC/USR key is active
$validateApiBlob = validateApiKey($uids->reqBy);

//print_r($validateApiBlob['APIKEY']);
//print_r($validateApiBlob['IDENTITY']);
//print_r($validateApiBlob['REQBY']);
//die();

function uniqidReal($lenght = 13) {
    // uniqid gives 13 chars, but you could adjust it to your needs.
    if (function_exists("random_bytes")) {
        $bytes = random_bytes(ceil($lenght / 2));
    } elseif (function_exists("openssl_random_pseudo_bytes")) {
        $bytes = openssl_random_pseudo_bytes(ceil($lenght / 2));
    } else {
        throw new Exception("no cryptographically secure random function available");
    }
    return substr(bin2hex($bytes), 0, $lenght);
}

$tmpKeyStorage = uniqidReal($lenght);
$uids->uniqueKey = $tmpKeyStorage;

// Check if ID already exists in DB 
// TODO : (need a function so we can recursively check if we're happen to get twice on the same UID)
$uids->readOne();
$uids_arr = array(
	"ID" => $uids->id,
	"CREATED" => $uids->timestamp,
	"UID" => $uids->uniqueKey,
  "REQ_BY" => $uids->reqBy,
  "REQ_BY_NAME" => $uids->reqByName
);

if ($uids->id == null) {
   //$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : $reqBy = "none";
   $uids->uniqueKey = $tmpKeyStorage;
   $uids->reqBy = $apiKeys->apiKey;
   $uids->reqByName = $validateApiBlob['REQBY'];

   $uids->create();
   $uids->uniqueKey = $tmpKeyStorage;

   $uids->readOne();
	 $uids_arr = array(
        	"ID" => $uids->id,
         	"CREATED" => $uids->timestamp,
        	"UID" => $uids->uniqueKey,
          "REQ_BY" => $uids->reqBy,
          "REQ_BY_NAME" => $uids->reqByName
	);
	print_r(json_encode($uids_arr));

} else {
  print_r(json_encode($uids_arr));
}


//for($i=0;$i<20;$i++) {
//    echo uniqidReal(), PHP_EOL;
//}

//echo $generatedID, PHP_EOL;

//echo 'Yess';
?>
