<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../config/database_multiplicity.php';

// instantiate uids object
include_once '../objects/uids.php';
include_once '../objects/users.php';
include_once '../objects/services.php';
include_once '../objects/apikeys.php';
include_once '../objects/apilogs.php';

$api_Service = 'getUniqId';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);
$apiKeys = new apiKeys($db);
$users = new users($db);
$services = new services($db);
$apiLogs = new apiLogs($db);

// get posted data
$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName) {
        echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}';
        die();
}

//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

// Check if API Key is valid & Active
// Check if we have a User Key or Service Key
//  Check is the SVC/USR key is active

$apiKeys->apiKey = $uids->reqBy; // store reqBy
$apiKeys->readOne();
//    $apiKeys_arr = array(
//      "ID" => $apiKeys->apiKeyID,
//      "CREATED" => $apiKeys->created,
//      "UPDATED" => $apiKeys->updated,
//      "API_KEY" => $apiKeys->apiKey,
//      "IS_USER" => $apiKeys->isUser,
//      "FOREIGN_ID" => $apiKeys->foreignID,
//      "IS_ACTIVE" => $apiKeys->isActive
//    );
//    print_r(json_encode($apiKeys_arr));
//die();

$users->userID = $apiKeys->foreignID;

function writeAPILog($apiLogs, $__apiKey, $__apiService, $__success, $__log) {
  $apiLogs->reqBy = $__apiKey;
  $apiLogs->service = $__apiService;
  $apiLogs->isSuccess = $__success;
  $apiLogs->apiLog = $__log;

  $apiLogs->create(); 
}

## Check 1 : Is API Key Active ?
if ($apiKeys->apiKeyID == null) {
  echo '{', PHP_EOL, '"message": "Error : apiKey \'' . $apiKeys->apiKey . '\' does not exist."', PHP_EOL, '}';
  die();
} elseif ($apiKeys->isActive == "0" ) {
  echo '{', PHP_EOL, '"message": "Error : apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';
  die();  
} else {
  // API Key exists
  if ($apiKeys->isUser == 1) { // User
    // User
    $users->readOne();
    $users_arr = array(
      "ID" => $users->userID,
      "CREATED" => $users->created,
      "UPDATED" => $users->updated,
      "TRIGRAM" => $users->trigram,
      "TRIGRAM_KEY" => $users->trigramKey,
      "SESSION_COOKIE" => $users->sessionCookie,
      "FNAME" => $users->firstName,
      "LNAME" => $users->lastName,
      "IS_ACTIVE" => $users->isActive
    );

    // is User Active ?
    if ($users->isActive == 0) {
      echo '{', PHP_EOL, '"message": "Error : user associated to apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';

      writeAPILog($apiLogs, $apiKeys->apiKey, $api_Service, 0, "Error: user is not active");

      die();
    } else {
      $tmpReqByName = $users->trigram;
    }
  } else { // Service
    $services->serviceID = $apiKeys->foreignID;
    $services->readOne();
    if ($services->isActive == 0) {
      echo '{', PHP_EOL, '"message": "Error : service associated to apiKey \'' . $apiKeys->apiKey . '\' is not active."', PHP_EOL, '}';

      writeAPILog($apiLogs, $apiKeys->apiKey, $api_Service, 0, "Error: user is not active");

      die();
    } else {
      // user is active ==> Log ==> Done 
      echo '{', PHP_EOL, '"message": "Working ! : user associated to apiKey \'' . $apiKeys->apiKey . '\' is active."', PHP_EOL, '}';
      $tmpReqByName = $services->serviceName;
    }    

  }
}

function uniqidReal($lenght = 13) {
    // uniqid gives 13 chars, but you could adjust it to your needs.
    if (function_exists("random_bytes")) {
        $bytes = random_bytes(ceil($lenght / 2));
    } elseif (function_exists("openssl_random_pseudo_bytes")) {
        $bytes = openssl_random_pseudo_bytes(ceil($lenght / 2));
    } else {
        throw new Exception("no cryptographically secure random function available");
    }
    return substr(bin2hex($bytes), 0, $lenght);
}

$tmpKeyStorage = uniqidReal($lenght);
$uids->uniqueKey = $tmpKeyStorage;

// Check if ID already exists in DB 
// TODO : (need a function so we can recursively check if we're happen to get twice on the same UID)
$uids->readOne();
$uids_arr = array(
	"ID" => $uids->id,
	"CREATED" => $uids->timestamp,
	"UID" => $uids->uniqueKey,
  "REQ_BY" => $uids->reqBy,
  "REQ_BY_NAME" => $uids->reqByName
);

if ($uids->id == null) {
   //$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : $reqBy = "none";
   $uids->uniqueKey = $tmpKeyStorage;
   $uids->reqBy = $apiKeys->apiKey;
   $uids->reqByName = $tmpReqByName;

   $uids->create();
   $uids->uniqueKey = $tmpKeyStorage;

   $uids->readOne();
	 $uids_arr = array(
        	"ID" => $uids->id,
         	"CREATED" => $uids->timestamp,
        	"UID" => $uids->uniqueKey,
          "REQ_BY" => $uids->reqBy,
          "REQ_BY_NAME" => $uids->reqByName
	);
	print_r(json_encode($uids_arr));

} else {
  print_r(json_encode($uids_arr));
}


//for($i=0;$i<20;$i++) {
//    echo uniqidReal(), PHP_EOL;
//}

//echo $generatedID, PHP_EOL;

//echo 'Yess';
?>
