<?php
class stack_dc{

    // database connection and table clientKey
    private $conn;
    private $table_STACK_DC = "T_STACK_DC";

    // object properties
    public $stackDC_ID;
    public $stackDC_created;
    public $stackDC_updated;
    public $stackDC_hostedOn;    
    public $stackDC_UID;    
    public $stackDC_genAPIKey;
    public $stackDC_isVpnEnabled;
    public $stackDC_isVpnNeeded;
    public $stackDC_ramUsage;
    public $stackDC_cpuUsage;
    public $stackDC_diskUsage;
    public $stackDC_regStatus;
    public $stackDC_status;
    public $stackDC_lastSeen;
    public $stackDC_masterKey;

    // constructor with $db as database connection
    public function __construct($db){
        $this->conn = $db;
    }

    // read all STACK_DC
/*    function read(){
        $query = "
        SELECT actionID, timestamp, askedByClient, targetPodUID, targetRelayID, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_STACK_DC . "
        GROUP BY targetPodUID
        ORDER BY timestamp DESC";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        // execute query
        $stmt->execute();

        return $stmt;
    }
*/

    /*  READ ONE
    **  : From ID
    **  Returns 1 Matching result
    **
    */
    function readOne() {
        // ID is obfuscated
        $query = "
        SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_STACK_DC . "
        WHERE `ID` = '" . $this->stackDC_ID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stackDC_ID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stackDC_ID=htmlspecialchars(strip_tags($this->stackDC_ID));
        $this->stackDC_created=htmlspecialchars(strip_tags($this->stackDC_created));
        $this->stackDC_updated=htmlspecialchars(strip_tags($this->stackDC_updated));
        $this->stackDC_hostedOn=htmlspecialchars(strip_tags($this->stackDC_hostedOn));
        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_genAPIKey=htmlspecialchars(strip_tags($this->stackDC_genAPIKey));
        $this->stackDC_isVpnEnabled=htmlspecialchars(strip_tags($this->stackDC_isVpnEnabled));
        $this->stackDC_isVpnNeeded=htmlspecialchars(strip_tags($this->stackDC_isVpnNeeded));
        $this->stackDC_ramUsage=htmlspecialchars(strip_tags($this->stackDC_ramUsage));
        $this->stackDC_cpuUsage=htmlspecialchars(strip_tags($this->stackDC_cpuUsage));
        $this->stackDC_diskUsage=htmlspecialchars(strip_tags($this->stackDC_diskUsage));
        $this->stackDC_regStatus=htmlspecialchars(strip_tags($this->stackDC_regStatus));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        $this->stackDC_masterKey=htmlspecialchars(strip_tags($this->stackDC_masterKey));


        // set values to object properties
        $this->stackDC_ID = $row['ID'];
        $this->stackDC_created = $row['CREATED'];
        $this->stackDC_updated = $row['UPDATED'];

        $this->stackDC_hostedOn = $row['HOSTED_ON'];
        $this->stackDC_UID = $row['STACK_DC_UID'];
        $this->stackDC_genAPIKey = $row['GEN_API_KEY'];
        $this->stackDC_isVpnEnabled = $row['IS_VPN_ENABLED'];
        $this->stackDC_isVpnNeeded = $row['IS_VPN_NEEDED'];
        $this->stackDC_ramUsage = $row['RAM_USAGE'];
        $this->stackDC_cpuUsage = $row['CPU_USAGE'];
        $this->stackDC_regStatus = $row['REG_STATUS'];
        $this->stackDC_status = $row['STATUS'];
        $this->stackDC_lastSeen = $row['LAST_SEEN'];


        if ( $this->stackDC_masterKey != "alpine" ) {
            $this->stackDC_ID = "obfuscated";
        }
        //var_dump($this->userID);
    }

    function readOneFromUID() {
        // ID is obfuscated
        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));

        $query = "
        SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_STACK_DC . "
        WHERE `STACK_DC_UID` = '" . $this->stackDC_UID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'


        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stackDC_UID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        //echo "query=" . $query;

        $this->stackDC_ID=htmlspecialchars(strip_tags($this->stackDC_ID));
        $this->stackDC_created=htmlspecialchars(strip_tags($this->stackDC_created));
        $this->stackDC_updated=htmlspecialchars(strip_tags($this->stackDC_updated));
        $this->stackDC_hostedOn=htmlspecialchars(strip_tags($this->stackDC_hostedOn));
        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_genAPIKey=htmlspecialchars(strip_tags($this->stackDC_genAPIKey));
        $this->stackDC_isVpnEnabled=htmlspecialchars(strip_tags($this->stackDC_isVpnEnabled));
        $this->stackDC_isVpnNeeded=htmlspecialchars(strip_tags($this->stackDC_isVpnNeeded));
        $this->stackDC_ramUsage=htmlspecialchars(strip_tags($this->stackDC_ramUsage));
        $this->stackDC_cpuUsage=htmlspecialchars(strip_tags($this->stackDC_cpuUsage));
        $this->stackDC_diskUsage=htmlspecialchars(strip_tags($this->stackDC_diskUsage));
        $this->stackDC_regStatus=htmlspecialchars(strip_tags($this->stackDC_regStatus));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        $this->stackDC_masterKey=htmlspecialchars(strip_tags($this->stackDC_masterKey));


        // set values to object properties
        $this->stackDC_ID = $row['ID'];
        $this->stackDC_created = $row['CREATED'];
        $this->stackDC_updated = $row['UPDATED'];
        $this->stackDC_hostedOn = $row['HOSTED_ON'];
        $this->stackDC_UID = $row['STACK_DC_UID'];
        $this->stackDC_genAPIKey = $row['GEN_API_KEY'];
        $this->stackDC_isVpnEnabled = $row['IS_VPN_ENABLED'];
        $this->stackDC_isVpnNeeded = $row['IS_VPN_NEEDED'];
        $this->stackDC_ramUsage = $row['RAM_USAGE'];
        $this->stackDC_cpuUsage = $row['CPU_USAGE'];
        $this->stackDC_diskUsage = $row['DISK_USAGE'];
        $this->stackDC_regStatus = $row['REG_STATUS'];
        $this->stackDC_status = $row['STATUS'];
        $this->stackDC_lastSeen = $row['LAST_SEEN'];


        // TODO : Fix that issue... 
        //if ( $this->masterKey != "alpine" ) {
        //    $this->host_ID = "obfuscated";
        //}
        //var_dump($this->userID);
    }

    function readOneFromHostedOnID() {
        // ID is obfuscated
        $this->stackDC_hostedOn=htmlspecialchars(strip_tags($this->stackDC_hostedOn));

        $query = "
        SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN
        FROM
        " . $this->table_STACK_DC . "
        WHERE `HOSTED_ON` = '" . $this->stackDC_hostedOn . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stackDC_hostedOn);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stackDC_ID=htmlspecialchars(strip_tags($this->stackDC_ID));
        $this->stackDC_created=htmlspecialchars(strip_tags($this->stackDC_created));
        $this->stackDC_updated=htmlspecialchars(strip_tags($this->stackDC_updated));
        $this->stackDC_hostedOn=htmlspecialchars(strip_tags($this->stackDC_hostedOn));
        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_genAPIKey=htmlspecialchars(strip_tags($this->stackDC_genAPIKey));
        $this->stackDC_isVpnEnabled=htmlspecialchars(strip_tags($this->stackDC_isVpnEnabled));
        $this->stackDC_isVpnNeeded=htmlspecialchars(strip_tags($this->stackDC_isVpnNeeded));
        $this->stackDC_ramUsage=htmlspecialchars(strip_tags($this->stackDC_ramUsage));
        $this->stackDC_cpuUsage=htmlspecialchars(strip_tags($this->stackDC_cpuUsage));
        $this->stackDC_diskUsage=htmlspecialchars(strip_tags($this->stackDC_diskUsage));
        $this->stackDC_regStatus=htmlspecialchars(strip_tags($this->stackDC_regStatus));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        $this->stackDC_masterKey=htmlspecialchars(strip_tags($this->stackDC_masterKey));


        // set values to object properties
        $this->stackDC_ID = $row['ID'];
        $this->stackDC_created = $row['CREATED'];
        $this->stackDC_updated = $row['UPDATED'];
        $this->stackDC_hostedOn = $row['HOSTED_ON'];
        $this->stackDC_UID = $row['STACK_DC_UID'];
        $this->stackDC_genAPIKey = $row['GEN_API_KEY'];
        $this->stackDC_isVpnEnabled = $row['IS_VPN_ENABLED'];
        $this->stackDC_isVpnNeeded = $row['IS_VPN_NEEDED'];
        $this->stackDC_ramUsage = $row['RAM_USAGE'];
        $this->stackDC_cpuUsage = $row['CPU_USAGE'];
        $this->stackDC_regStatus = $row['REG_STATUS'];
        $this->stackDC_status = $row['STATUS'];
        $this->stackDC_lastSeen = $row['LAST_SEEN'];


        // TODO : Fix that issue... 
        //if ( $this->masterKey != "alpine" ) {
        //    $this->host_ID = "obfuscated";
        //}
        //var_dump($this->userID);
    }

   // create Host
    function create(){
        // query to insert record
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $query = "INSERT INTO
                " . $this->table_STACK_DC . "
                SET
                `" . "HOSTED_ON" . "`= '". $this->stackDC_hostedOn ."',
                `" . "STACK_DC_UID" . "`= '". $this->stackDC_UID ."',
                `" . "GEN_API_KEY" . "`= '". $this->stackDC_genAPIKey ."',
            	`" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
		";


        // UID=:UID";

        //podUID=:podUID, cpu_usage=:cpu_usage, cpu_temp=:cpu_temp, ram_usage=:ram_usage, hdd_usage=:hdd_usage, pod_temp=:pod_temp, pod_humidity=:pod_humidity

        // prepare query
        $stmt = $this->conn->prepare($query);
	   //var_dump($stmt);
        // sanitize
        $this->stackDC_hostedOn=htmlspecialchars(strip_tags($this->stackDC_hostedOn));
        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_genAPIKey=htmlspecialchars(strip_tags($this->stackDC_genAPIKey));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // bind values
        $stmt->bindParam(":HOSTED_ON", $this->stackDC_hostedOn);
        $stmt->bindParam(":STACK_DC_UID", $this->stackDC_UID);
        $stmt->bindParam(":GEN_API_KEY", $this->stackDC_genAPIKey);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this->uniqueKey);

        // execute query
        if($stmt->execute()){
            return true;
        }
        return false;

    }


    // From UID
    function editSystemStatus(){
        // sanitize
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_ramUsage=htmlspecialchars(strip_tags($this->stackDC_ramUsage));
        $this->stackDC_cpuUsage=htmlspecialchars(strip_tags($this->stackDC_cpuUsage));
        $this->stackDC_diskUsage=htmlspecialchars(strip_tags($this->stackDC_diskUsage));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_STACK_DC . "
        SET
            `" . "RAM_USAGE" . "`= '". $this->stackDC_ramUsage ."',
            `" . "CPU_USAGE" . "`= '". $this->stackDC_cpuUsage ."',
            `" . "DISK_USAGE" . "`= '". $this->stackDC_diskUsage ."',
            `" . "STATUS" . "`= '". $this->stackDC_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
        WHERE
            `STACK_DC_UID` = '" . $this->stackDC_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":RAM_USAGE", $this->stackDC_ramUsage);
        $stmt->bindParam(":CPU_USAGE", $this->stackDC_cpuUsage);
        $stmt->bindParam(":DISK_USAGE", $this->stackDC_diskUsage);
        $stmt->bindParam(":STATUS", $this->stackDC_status);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function editRegisteringState(){
        // sanitize
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_regStatus=htmlspecialchars(strip_tags($this->stackDC_regStatus));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_STACK_DC . "
        SET
            `" . "REG_STATUS" . "`= '". $this->stackDC_regStatus ."',
            `" . "STATUS" . "`= '". $this->stackDC_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
        WHERE
            `STACK_DC_UID` = '" . $this->stackDC_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":REG_STATUS", $this->stackDC_regStatus);
        $stmt->bindParam(":STATUS", $this->stackDC_status);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }


    // From UID
    function editVPNStatus(){
        // sanitize
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_isVpnEnabled=htmlspecialchars(strip_tags($this->stackDC_isVpnEnabled));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_STACK_DC . "
        SET
            `" . "IS_VPN_ENABLED" . "`= '". $this->stackDC_isVpnEnabled ."',
            `" . "STATUS" . "`= '". $this->stackDC_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
        WHERE
            `STACK_DC_UID` = '" . $this->stackDC_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":IS_VPN_ENABLED", $this->stackDC_isVpnEnabled);
        $stmt->bindParam(":STATUS", $this->stackDC_status);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function editVPNNeeded(){
        // sanitize
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACK_DC_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_isVpnNeeded=htmlspecialchars(strip_tags($this->stackDC_isVpnNeeded));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_STACK_DC . "
        SET
            `" . "IS_VPN_NEEDED" . "`= '". $this->stackDC_isVpnNeeded ."',
            `" . "STATUS" . "`= '". $this->stackDC_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
        WHERE
            `STACK_DC_UID` = '" . $this->stackDC_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":IS_VPN_NEEDED", $this->stackDC_isVpnNeeded);
        $stmt->bindParam(":STATUS", $this->stackDC_status);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }


    // used when filling up the update product form
/*    function readLast(){
        $query = "
        SELECT actionID, targetPodUID, timestamp, targetRelayID, askedByClient, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_STACK_DC . "
        WHERE `targetPodUID` = '" . $this->targetPodUID . "' AND `actionStatus` = '" . "submitted" . "'
        ORDER BY actionID ASC LIMIT 0,1";
        //AND `askedByClient` = '" . $this->askedByClient . "'

        //var_dump($query);

        // prepare query statement
        $stmt = $this->conn->prepare( $query );

        // bind id of product to be updated
        $stmt->bindParam(1, $this->targetPodUID);

        // execute query
        $stmt->execute();

        // get retrieved row
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        $this->actionID=htmlspecialchars(strip_tags($this->actionID));
        $this->targetPodUID=htmlspecialchars(strip_tags($this->targetPodUID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->targetRelayID=htmlspecialchars(strip_tags($this->targetRelayID));
        $this->askedByClient=htmlspecialchars(strip_tags($this->askedByClient));
        $this->action=htmlspecialchars(strip_tags($this->action));
        $this->actionStatus=htmlspecialchars(strip_tags($this->actionStatus));
        $this->acknoledgedTT=htmlspecialchars(strip_tags($this->acknoledgedTT));
        $this->startedTT=htmlspecialchars(strip_tags($this->startedTT));
        $this->doneTT=htmlspecialchars(strip_tags($this->doneTT));

        // set values to object properties
        $this->actionID = $row['actionID'];
        $this->targetPodUID = $row['targetPodUID'];
        $this->timestamp = $row['timestamp'];
        $this->targetRelayID = $row['targetRelayID'];
        $this->askedByClient = $row['askedByClient'];
        $this->action = $row['action'];
        $this->actionStatus = $row['actionStatus'];
        $this->acknoledgedTT = $row['acknoledgedTT'];
        $this->startedTT = $row['startedTT'];
        $this->doneTT = $row['doneTT'];
    }

    function editSystemInfo(){
        // sanitize
        $this->systemInfoID=htmlspecialchars(strip_tags($this->systemInfoID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->podUID=htmlspecialchars(strip_tags($this->podUID));
        $this->cpu_usage=htmlspecialchars(strip_tags($this->cpu_usage));
        $this->cpu_temp=htmlspecialchars(strip_tags($this->cpu_temp));
        $this->ram_usage=htmlspecialchars(strip_tags($this->ram_usage));
        $this->hdd_usage=htmlspecialchars(strip_tags($this->hdd_usage));
        $this->pod_temp=htmlspecialchars(strip_tags($this->pod_temp));
        $this->pod_humidity=htmlspecialchars(strip_tags($this->pod_humidity));

        // update query
        $query = "UPDATE
            " . $this->table_STACK_DC . "
        SET
            `" . "timestamp" . "`= '". $this->timestamp ."',
            `" . "cpu_usage" . "`= '". $this->cpu_usage ."',
            `" . "cpu_temp" . "`= '". $this->cpu_temp ."',
            `" . "ram_usage" . "`= '". $this->ram_usage ."',
            `" . "hdd_usage" . "`= '". $this->hdd_usage ."',
            `" . "pod_temp" . "`= '". $this->pod_temp ."',
            `" . "pod_humidity" . "`= '". $this->pod_humidity ."'
        WHERE
            `podUID` = '" . $this->podUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":cpu_usage", $this->cpu_usage);
        $stmt->bindParam(":cpu_temp", $this->cpu_temp);
        $stmt->bindParam(":ram_usage", $this->ram_usage);
        $stmt->bindParam(":hdd_usage", $this->hdd_usage);
        $stmt->bindParam(":pod_temp", $this->pod_temp);
        $stmt->bindParam(":pod_humidity", $this->pod_humidity);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }*/
}

?>
