<?php

class stacks{

    // database connection and table clientKey
    private $conn;
    private $table_STACKS = "T_STACKS";

    // object properties
    public $stacks_ID;
    public $stacks_name;
    public $stacks_created;
    public $stacks_updated;    
    public $stacks_UID;    
    public $stacks_hostedOn;
    public $stacks_hostingDC;
    public $stacks_nbStackVM;
    public $stacks_nbStackVMOn;
    public $stacks_nbVMOnline;
    public $stacks_nbVMAvail;
    public $stacks_regStatus;
    public $stacks_status;
    public $stacks_provStatus;
    public $stacks_provJobStatus;
    public $stacks_provJobPending;
    public $stacks_provJobRunning;
    public $stacks_lastSeen;
    public $stacks_masterKey;

    // constructor with $db as database connection
    public function __construct($db){
        $this->conn = $db;
    }

    // read all STACKS
/*    function read(){
        $query = "
        SELECT actionID, timestamp, askedByClient, targetPodUID, targetRelayID, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_STACKS . "
        GROUP BY targetPodUID
        ORDER BY timestamp DESC";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        // execute query
        $stmt->execute();

        return $stmt;
    }
*/

    /*  READ ONE
    **  : From ID
    **  Returns 1 Matching result
    **
    */
    function readOne() {
        // ID is obfuscated
        $query = "
        SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN
        FROM
        " . $this->table_STACKS . "
        WHERE `ID` = '" . $this->stacks_ID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stacks_ID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stacks_ID=htmlspecialchars(strip_tags($this->stacks_ID));
        $this->stacks_name=htmlspecialchars(strip_tags($this->stacks_name));
        $this->stacks_created=htmlspecialchars(strip_tags($this->stacks_created));
        $this->stacks_updated=htmlspecialchars(strip_tags($this->stacks_updated));
        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));
        $this->stacks_nbStackVM=htmlspecialchars(strip_tags($this->stacks_nbStackVM));
        $this->stacks_nbStackVMOn=htmlspecialchars(strip_tags($this->stacks_nbStackVMOn));
        $this->stacks_nbVMOnline=htmlspecialchars(strip_tags($this->stacks_nbVMOnline));
        $this->stacks_nbVMAvail=htmlspecialchars(strip_tags($this->stacks_nbVMAvail));
        $this->stacks_regStatus=htmlspecialchars(strip_tags($this->stacks_regStatus));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_provJobStatus=htmlspecialchars(strip_tags($this->stacks_provJobStatus));
        $this->stacks_provJobPending=htmlspecialchars(strip_tags($this->stacks_provJobPending));
        $this->stacks_provJobRunning=htmlspecialchars(strip_tags($this->stacks_provJobRunning));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));

        $this->host_masterKey=htmlspecialchars(strip_tags($this->host_masterKey));


        // set values to object properties
        $this->stacks_ID = $row['ID'];
        $this->stacks_name = $row['NAME'];
        $this->stacks_created = $row['CREATED'];
        $this->stacks_updated = $row['UPDATED'];
        $this->stacks_UID = $row['STACK_UID'];
        $this->stacks_hostedOn = $row['HOSTED_ON'];
        $this->stacks_hostingDC = $row['HOSTING_DC'];
        $this->stacks_nbStackVM = $row['NB_STACK_VM'];
        $this->stacks_nbStackVMOn = $row['NB_STACK_VM_ON'];
        $this->stacks_nbVMOnline = $row['NB_VMS_ONLINE'];
        $this->stacks_nbVMAvail = $row['NB_VMS_AVAIL'];
        $this->stacks_regStatus = $row['REG_STATUS'];
        $this->stacks_status = $row['STATUS'];
        $this->stacks_provStatus = $row['PROV_STATUS'];
        $this->stacks_provJobStatus = $row['PROV_JOB_STATUS'];
        $this->stacks_provJobPending = $row['PROV_JOB_PENDING'];
        $this->stacks_provJobRunning = $row['PROV_JOB_RUNNING'];
        $this->stacks_lastSeen = $row['LAST_SEEN'];

        if ( $this->masterKey != "alpine" ) {
            $this->stacks_ID = "obfuscated";
        }
        //var_dump($this->userID);
    }

    function readOneFromUID() {
        // ID is obfuscated
        $query = "
        SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN
        FROM
        " . $this->table_STACKS . "
        WHERE `STACK_UID` = '" . $this->stacks_UID . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stacks_UID);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stacks_ID=htmlspecialchars(strip_tags($this->stacks_ID));
        $this->stacks_name=htmlspecialchars(strip_tags($this->stacks_name));
        $this->stacks_created=htmlspecialchars(strip_tags($this->stacks_created));
        $this->stacks_updated=htmlspecialchars(strip_tags($this->stacks_updated));
        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));
        $this->stacks_nbStackVM=htmlspecialchars(strip_tags($this->stacks_nbStackVM));
        $this->stacks_nbStackVMOn=htmlspecialchars(strip_tags($this->stacks_nbStackVMOn));
        $this->stacks_nbVMOnline=htmlspecialchars(strip_tags($this->stacks_nbVMOnline));
        $this->stacks_nbVMAvail=htmlspecialchars(strip_tags($this->stacks_nbVMAvail));
        $this->stacks_regStatus=htmlspecialchars(strip_tags($this->stacks_regStatus));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_provJobStatus=htmlspecialchars(strip_tags($this->stacks_provJobStatus));
        $this->stacks_provJobPending=htmlspecialchars(strip_tags($this->stacks_provJobPending));
        $this->stacks_provJobRunning=htmlspecialchars(strip_tags($this->stacks_provJobRunning));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));

        $this->stacks_masterKey=htmlspecialchars(strip_tags($this->stacks_masterKey));


        // set values to object properties
        $this->stacks_ID = $row['ID'];
        $this->stacks_name = $row['NAME'];
        $this->stacks_created = $row['CREATED'];
        $this->stacks_updated = $row['UPDATED'];
        $this->stacks_UID = $row['STACK_UID'];
        $this->stacks_hostedOn = $row['HOSTED_ON'];
        $this->stacks_hostingDC = $row['HOSTING_DC'];
        $this->stacks_nbStackVM = $row['NB_STACK_VM'];
        $this->stacks_nbStackVMOn = $row['NB_STACK_VM_ON'];
        $this->stacks_nbVMOnline = $row['NB_VMS_ONLINE'];
        $this->stacks_nbVMAvail = $row['NB_VMS_AVAIL'];
        $this->stacks_regStatus = $row['REG_STATUS'];
        $this->stacks_status = $row['STATUS'];
        $this->stacks_provStatus = $row['PROV_STATUS'];
        $this->stacks_provJobStatus = $row['PROV_JOB_STATUS'];
        $this->stacks_provJobPending = $row['PROV_JOB_PENDING'];
        $this->stacks_provJobRunning = $row['PROV_JOB_RUNNING'];
        $this->stacks_lastSeen = $row['LAST_SEEN'];

        /// TODO Do something about that.
        //if ( $this->stacks_masterKey != "alpine" ) {
        //    $this->stacks_ID = "obfuscated";
        //}
        //var_dump($this->userID);
    }

    function readOneFromHostedOnID() {
        // ID is obfuscated
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));

        $query = "
        SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN
        FROM
        " . $this->table_STACKS . "
        WHERE `HOSTED_ON` = '" . $this->stacks_hostedOn . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stacks_hostedOn);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stacks_ID=htmlspecialchars(strip_tags($this->stacks_ID));
        $this->stacks_name=htmlspecialchars(strip_tags($this->stacks_name));
        $this->stacks_created=htmlspecialchars(strip_tags($this->stacks_created));
        $this->stacks_updated=htmlspecialchars(strip_tags($this->stacks_updated));
        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));
        $this->stacks_nbStackVM=htmlspecialchars(strip_tags($this->stacks_nbStackVM));
        $this->stacks_nbStackVMOn=htmlspecialchars(strip_tags($this->stacks_nbStackVMOn));
        $this->stacks_nbVMOnline=htmlspecialchars(strip_tags($this->stacks_nbVMOnline));
        $this->stacks_nbVMAvail=htmlspecialchars(strip_tags($this->stacks_nbVMAvail));
        $this->stacks_regStatus=htmlspecialchars(strip_tags($this->stacks_regStatus));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_provJobStatus=htmlspecialchars(strip_tags($this->stacks_provJobStatus));
        $this->stacks_provJobPending=htmlspecialchars(strip_tags($this->stacks_provJobPending));
        $this->stacks_provJobRunning=htmlspecialchars(strip_tags($this->stacks_provJobRunning));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));

        $this->stacks_masterKey=htmlspecialchars(strip_tags($this->stacks_masterKey));


        // set values to object properties
        $this->stacks_ID = $row['ID'];
        $this->stacks_name = $row['NAME'];
        $this->stacks_created = $row['CREATED'];
        $this->stacks_updated = $row['UPDATED'];
        $this->stacks_UID = $row['STACK_UID'];
        $this->stacks_hostedOn = $row['HOSTED_ON'];
        $this->stacks_hostingDC = $row['HOSTING_DC'];
        $this->stacks_nbStackVM = $row['NB_STACK_VM'];
        $this->stacks_nbStackVMOn = $row['NB_STACK_VM_ON'];
        $this->stacks_nbVMOnline = $row['NB_VMS_ONLINE'];
        $this->stacks_nbVMAvail = $row['NB_VMS_AVAIL'];
        $this->stacks_regStatus = $row['REG_STATUS'];
        $this->stacks_status = $row['STATUS'];
        $this->stacks_provStatus = $row['PROV_STATUS'];
        $this->stacks_provJobStatus = $row['PROV_JOB_STATUS'];
        $this->stacks_provJobPending = $row['PROV_JOB_PENDING'];
        $this->stacks_provJobRunning = $row['PROV_JOB_RUNNING'];
        $this->stacks_lastSeen = $row['LAST_SEEN'];

        /// TODO Do something about that.
        //if ( $this->stacks_masterKey != "alpine" ) {
        //    $this->stacks_ID = "obfuscated";
        //}
        //var_dump($this->userID);  
    }

    function readOneFromHostingDCID() {
        // ID is obfuscated
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));

        $query = "
        SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN
        FROM
        " . $this->table_STACKS . "
        WHERE `HOSTING_DC` = '" . $this->stacks_hostingDC . "'
        LIMIT 0,1";
        // AND `clientKey` = '" . $this->clientKey . "'

        $stmt = $this->conn->prepare( $query );
        $stmt->bindParam(1, $this->stacks_hostingDC);
        $stmt->execute();
        $row = $stmt->fetch(PDO::FETCH_ASSOC);
        //var_dump($row);

        $this->stacks_ID=htmlspecialchars(strip_tags($this->stacks_ID));
        $this->stacks_name=htmlspecialchars(strip_tags($this->stacks_name));
        $this->stacks_created=htmlspecialchars(strip_tags($this->stacks_created));
        $this->stacks_updated=htmlspecialchars(strip_tags($this->stacks_updated));
        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));
        $this->stacks_nbStackVM=htmlspecialchars(strip_tags($this->stacks_nbStackVM));
        $this->stacks_nbStackVMOn=htmlspecialchars(strip_tags($this->stacks_nbStackVMOn));
        $this->stacks_nbVMOnline=htmlspecialchars(strip_tags($this->stacks_nbVMOnline));
        $this->stacks_nbVMAvail=htmlspecialchars(strip_tags($this->stacks_nbVMAvail));
        $this->stacks_regStatus=htmlspecialchars(strip_tags($this->stacks_regStatus));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_provJobStatus=htmlspecialchars(strip_tags($this->stacks_provJobStatus));
        $this->stacks_provJobPending=htmlspecialchars(strip_tags($this->stacks_provJobPending));
        $this->stacks_provJobRunning=htmlspecialchars(strip_tags($this->stacks_provJobRunning));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));

        $this->stacks_masterKey=htmlspecialchars(strip_tags($this->stacks_masterKey));


        // set values to object properties
        $this->stacks_ID = $row['ID'];
        $this->stacks_name = $row['NAME'];
        $this->stacks_created = $row['CREATED'];
        $this->stacks_updated = $row['UPDATED'];
        $this->stacks_UID = $row['STACK_UID'];
        $this->stacks_hostedOn = $row['HOSTED_ON'];
        $this->stacks_hostingDC = $row['HOSTING_DC'];
        $this->stacks_nbStackVM = $row['NB_STACK_VM'];
        $this->stacks_nbStackVMOn = $row['NB_STACK_VM_ON'];
        $this->stacks_nbVMOnline = $row['NB_VMS_ONLINE'];
        $this->stacks_nbVMAvail = $row['NB_VMS_AVAIL'];
        $this->stacks_regStatus = $row['REG_STATUS'];
        $this->stacks_status = $row['STATUS'];
        $this->stacks_provStatus = $row['PROV_STATUS'];
        $this->stacks_provJobStatus = $row['PROV_JOB_STATUS'];
        $this->stacks_provJobPending = $row['PROV_JOB_PENDING'];
        $this->stacks_provJobRunning = $row['PROV_JOB_RUNNING'];
        $this->stacks_lastSeen = $row['LAST_SEEN'];

        /// TODO Do something about that.
        //if ( $this->stacks_masterKey != "alpine" ) {
        //    $this->stacks_ID = "obfuscated";
        //}
        //var_dump($this->userID);  
    }

   // create Host
    function create(){
        // query to insert record
        // SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN

        // Hosting_DC cannot be known
        //                 `" . "HOSTING_DC" . "`= '". $this->stackDC_hostedOn ."',


        $query = "INSERT INTO
                " . $this->table_STACKS . "
                SET
                `" . "NAME" . "`= '". $this->stacks_name ."',
                `" . "STACK_UID" . "`= '". $this->stacks_UID ."',
                `" . "HOSTED_ON" . "`= '". $this->stacks_hostedOn ."',
            	`" . "LAST_SEEN" . "`= '". $this->stacks_lastSeen ."'
		;";


                   // UID=:UID";

        //podUID=:podUID, cpu_usage=:cpu_usage, cpu_temp=:cpu_temp, ram_usage=:ram_usage, hdd_usage=:hdd_usage, pod_temp=:pod_temp, pod_humidity=:pod_humidity

        // prepare query
        $stmt = $this->conn->prepare($query);
	   //var_dump($stmt);
        // sanitize
        $this->stacks_name=htmlspecialchars(strip_tags($this->stacks_name));
        $this->stacks_hostedOn=htmlspecialchars(strip_tags($this->stacks_hostedOn));
        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));

        // bind values
        $stmt->bindParam(":NAME", $this->stacks_name);
        $stmt->bindParam(":HOSTED_ON", $this->stacks_hostedOn);
        $stmt->bindParam(":STACK_UID", $this->stacks_UID);
        $stmt->bindParam(":LAST_SEEN", $this->stacks_lastSeen);

        //var_dump($this->uniqueKey);

        // execute query
        if($stmt->execute()){
            return true;
        }
        return false;
    }

    // From UID
    // Once, we're registred, DC will start registering and we need to attach DC's ID onto our STACK Info, rendering 
    function registerDC(){
        // sanitize
        // SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN

        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));
        $this->stacks_hostingDC=htmlspecialchars(strip_tags($this->stacks_hostingDC));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));


        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "HOSTING_DC" . "`= '". $this->stacks_hostingDC ."',
            `" . "STATUS" . "`= '". $this->stacks_status ."',
            `" . "PROV_STATUS" . "`= '". $this->stacks_provStatus ."',
            `" . "REG_STATUS" . "`= 'Registering',
            `" . "LAST_SEEN" . "`= '". $this->stacks_lastSeen ."'
        WHERE
            `STACK_UID` = '" . $this->stacks_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":HOSTING_DC", $this->stacks_hostingDC);
        $stmt->bindParam(":STATUS", $this->stacks_status);
        $stmt->bindParam(":PROV_STATUS", $this->stackDC_diskUsage);
        $stmt->bindParam(":LAST_SEEN", $this->stacks_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    // Once ready to go, everything registered we can edit PROV STATUS (JOB, PENDING, ...)
    function editProvisionningStatuses(){
        // sanitize
        // SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN

        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));

        $this->stacks_provStatus=htmlspecialchars(strip_tags($this->stacks_provStatus));
        $this->stacks_provJobStatus=htmlspecialchars(strip_tags($this->stacks_provJobStatus));
        $this->stacks_provJobPending=htmlspecialchars(strip_tags($this->stacks_provJobPending));
        $this->stacks_provJobRunning=htmlspecialchars(strip_tags($this->stacks_provJobRunning));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));


        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "PROV_STATUS" . "`= '". $this->stacks_provStatus ."',
            `" . "PROV_JOB_STATUS" . "`= '". $this->stacks_provJobStatus ."',
            `" . "PROV_JOB_PENDING" . "`= '". $this->stacks_provJobPending ."',
            `" . "PROV_JOB_RUNNING" . "`= '". $this->stacks_provJobRunning ."',
            `" . "LAST_SEEN" . "`= '". $this->stacks_lastSeen ."'
        WHERE
            `STACK_UID` = '" . $this->stacks_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":PROV_STATUS", $this->stacks_provStatus);
        $stmt->bindParam(":PROV_JOB_STATUS", $this->stacks_provJobStatus);
        $stmt->bindParam(":PROV_JOB_PENDING", $this->stacks_provJobPending);
        $stmt->bindParam(":PROV_JOB_RUNNING", $this->stacks_provJobRunning);
        $stmt->bindParam(":LAST_SEEN", $this->stacks_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    // Edit VM count + VMs avail (hint: need call from HOST to get Compute availability...)
    function editProvisionnedVMData(){
        // sanitize
        // SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN

        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));

        $this->stacks_nbVMOnline=htmlspecialchars(strip_tags($this->stacks_nbVMOnline));
        $this->stacks_nbVMAvail=htmlspecialchars(strip_tags($this->stacks_nbVMAvail));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));


        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "NB_VMS_ONLINE" . "`= '". $this->stacks_nbVMOnline ."',
            `" . "NB_VMS_AVAIL" . "`= '". $this->stacks_nbVMAvail ."',
            `" . "STATUS" . "`= '". $this->stacks_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stacks_lastSeen ."'
        WHERE
            `STACK_UID` = '" . $this->stacks_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":NB_VMS_ONLINE", $this->stacks_nbVMOnline);
        $stmt->bindParam(":NB_VMS_AVAIL", $this->stacks_nbVMAvail);
        $stmt->bindParam(":STATUS", $this->stacks_status);
        $stmt->bindParam(":LAST_SEEN", $this->stacks_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function editStackVMData(){
        // sanitize
        // SELECT ID, NAME, CREATED, UPDATED, STACK_UID, HOSTED_ON, HOSTING_DC, NB_STACK_VM, NB_STACK_VM_ON, NB_VMS_ONLINE, NB_VMS_AVAIL, REG_STATUS, STATUS, PROV_STATUS, PROV_JOB_STATUS, PROV_JOB_PENDING, PROV_JOB_RUNNING, LAST_SEEN

        $this->stacks_UID=htmlspecialchars(strip_tags($this->stacks_UID));

        $this->stacks_nbStackVM=htmlspecialchars(strip_tags($this->stacks_nbStackVM));
        $this->stacks_nbStackVMOn=htmlspecialchars(strip_tags($this->stacks_nbStackVMOn));
        $this->stacks_status=htmlspecialchars(strip_tags($this->stacks_status));
        $this->stacks_lastSeen=htmlspecialchars(strip_tags($this->stacks_lastSeen));


        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "NB_STACK_VM_ON" . "`= '". $this->stacks_nbStackVMOn ."',
            `" . "NB_STACK_VM" . "`= '". $this->stacks_nbStackVM ."',
            `" . "STATUS" . "`= '". $this->stacks_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stacks_lastSeen ."'
        WHERE
            `STACK_UID` = '" . $this->stacks_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":NB_STACK_VM_ON", $this->stacks_nbStackVMOn);
        $stmt->bindParam(":NB_STACK_VM", $this->stacks_nbStackVM);
        $stmt->bindParam(":STATUS", $this->stacks_status);
        $stmt->bindParam(":LAST_SEEN", $this->stacks_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }

    // From UID
    function editRegisteringState(){
        // sanitize
        // SELECT ID, CREATED, UPDATED, HOSTED_ON, STACKS_UID, GEN_API_KEY, IS_VPN_ENABLED, IS_VPN_NEEDED, RAM_USAGE, CPU_USAGE, DISK_USAGE, REG_STATUS, STATUS, LAST_SEEN

        $this->stackDC_UID=htmlspecialchars(strip_tags($this->stackDC_UID));
        $this->stackDC_regStatus=htmlspecialchars(strip_tags($this->stackDC_regStatus));
        $this->stackDC_status=htmlspecialchars(strip_tags($this->stackDC_status));
        $this->stackDC_lastSeen=htmlspecialchars(strip_tags($this->stackDC_lastSeen));

        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "REG_STATUS" . "`= '". $this->stackDC_regStatus ."',
            `" . "STATUS" . "`= '". $this->stackDC_status ."',
            `" . "LAST_SEEN" . "`= '". $this->stackDC_lastSeen ."'
        WHERE
            `STACKS_UID` = '" . $this->stackDC_UID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":REG_STATUS", $this->stackDC_regStatus);
        $stmt->bindParam(":STATUS", $this->stackDC_status);
        $stmt->bindParam(":LAST_SEEN", $this->stackDC_lastSeen);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }


    // used when filling up the update product form
/*    function readLast(){
        $query = "
        SELECT actionID, targetPodUID, timestamp, targetRelayID, askedByClient, action, actionStatus, acknoledgedTT, startedTT, doneTT
        FROM
        " . $this->table_STACKS . "
        WHERE `targetPodUID` = '" . $this->targetPodUID . "' AND `actionStatus` = '" . "submitted" . "'
        ORDER BY actionID ASC LIMIT 0,1";
        //AND `askedByClient` = '" . $this->askedByClient . "'

        //var_dump($query);

        // prepare query statement
        $stmt = $this->conn->prepare( $query );

        // bind id of product to be updated
        $stmt->bindParam(1, $this->targetPodUID);

        // execute query
        $stmt->execute();

        // get retrieved row
        $row = $stmt->fetch(PDO::FETCH_ASSOC);

        $this->actionID=htmlspecialchars(strip_tags($this->actionID));
        $this->targetPodUID=htmlspecialchars(strip_tags($this->targetPodUID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->targetRelayID=htmlspecialchars(strip_tags($this->targetRelayID));
        $this->askedByClient=htmlspecialchars(strip_tags($this->askedByClient));
        $this->action=htmlspecialchars(strip_tags($this->action));
        $this->actionStatus=htmlspecialchars(strip_tags($this->actionStatus));
        $this->acknoledgedTT=htmlspecialchars(strip_tags($this->acknoledgedTT));
        $this->startedTT=htmlspecialchars(strip_tags($this->startedTT));
        $this->doneTT=htmlspecialchars(strip_tags($this->doneTT));

        // set values to object properties
        $this->actionID = $row['actionID'];
        $this->targetPodUID = $row['targetPodUID'];
        $this->timestamp = $row['timestamp'];
        $this->targetRelayID = $row['targetRelayID'];
        $this->askedByClient = $row['askedByClient'];
        $this->action = $row['action'];
        $this->actionStatus = $row['actionStatus'];
        $this->acknoledgedTT = $row['acknoledgedTT'];
        $this->startedTT = $row['startedTT'];
        $this->doneTT = $row['doneTT'];
    }

    function editSystemInfo(){
        // sanitize
        $this->systemInfoID=htmlspecialchars(strip_tags($this->systemInfoID));
        $this->timestamp=htmlspecialchars(strip_tags($this->timestamp));
        $this->podUID=htmlspecialchars(strip_tags($this->podUID));
        $this->cpu_usage=htmlspecialchars(strip_tags($this->cpu_usage));
        $this->cpu_temp=htmlspecialchars(strip_tags($this->cpu_temp));
        $this->ram_usage=htmlspecialchars(strip_tags($this->ram_usage));
        $this->hdd_usage=htmlspecialchars(strip_tags($this->hdd_usage));
        $this->pod_temp=htmlspecialchars(strip_tags($this->pod_temp));
        $this->pod_humidity=htmlspecialchars(strip_tags($this->pod_humidity));

        // update query
        $query = "UPDATE
            " . $this->table_STACKS . "
        SET
            `" . "timestamp" . "`= '". $this->timestamp ."',
            `" . "cpu_usage" . "`= '". $this->cpu_usage ."',
            `" . "cpu_temp" . "`= '". $this->cpu_temp ."',
            `" . "ram_usage" . "`= '". $this->ram_usage ."',
            `" . "hdd_usage" . "`= '". $this->hdd_usage ."',
            `" . "pod_temp" . "`= '". $this->pod_temp ."',
            `" . "pod_humidity" . "`= '". $this->pod_humidity ."'
        WHERE
            `podUID` = '" . $this->podUID . "'
        ";

        // prepare query statement
        $stmt = $this->conn->prepare($query);

        //var_dump($stmt);

        // bind values
        $stmt->bindParam(":cpu_usage", $this->cpu_usage);
        $stmt->bindParam(":cpu_temp", $this->cpu_temp);
        $stmt->bindParam(":ram_usage", $this->ram_usage);
        $stmt->bindParam(":hdd_usage", $this->hdd_usage);
        $stmt->bindParam(":pod_temp", $this->pod_temp);
        $stmt->bindParam(":pod_humidity", $this->pod_humidity);

        //var_dump($this);

        // execute the query
        if($stmt->execute()){
            return true;
        }

        return false;
    }*/
}

?>
