<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
ini_set('display_errors', 'on');

error_reporting(E_ALL);

// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../../config/database_multiplicity.php';

// instantiate uids object
include_once '../../objects/uids.php';
include_once '../../objects/users.php';
include_once '../../objects/hosts.php';
include_once '../../objects/stacks.php';
include_once '../../objects/services.php';
include_once '../../objects/apikeys.php';
include_once '../../objects/apilogs.php';

include_once '../../lib/apiServices.php';

$api_Service = 'bind-stack-to-host';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);        // UniqID
$hosts = new hosts($db);      // Hosts 
$stacks = new stacks($db);      // Hosts 
$apiKeys = new apiKeys($db);  // apis
$users = new users($db);      // Users
$services = new services($db);  
$apiLogs = new apiLogs($db);

// get posted data
//$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  elseif ($type == 'POST') { echo '{', PHP_EOL, '"message": "Mendatroy variable missing : ' . $paramName . '."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function dieAfterCallbackError($param) {
  echo '{', PHP_EOL, '"error": could not retieve an ID!" --> ' . $param . '."', PHP_EOL, '}';
  die(); 
}

// That's when you have an API Key doh ! :D (from webby we dont have one :D)
function getUniqueID($apiKey) {
  $opts = [
    "http" => [
        "method" => "GET",
        "header" => "Accept-language: en\r\n" .
        "x-auth-apiKey: " . $apiKey . "\r\n"
    ]
  ];

  $context = stream_context_create($opts);
  $resp_getUniqueID = file_get_contents('http://127.0.0.1/ws/getUniqId.php?len=32', false, $context);
  $resp_getUniqueID = isset($resp_getUniqueID) ? $resp_getUniqueID : dieAfterCallbackError($resp_getUniqueID);

  $resp_getUniqueID = json_decode($resp_getUniqueID);

  return $resp_getUniqueID; // $resp_getUniqueID->UID needed to fecth the UID
}

function validateParametters($param, $valid_options) {
  $param = trim(strtolower($param), ' ');
  $valid_options_arr = explode(',', $valid_options);

  foreach ($valid_options_arr as $key => $valid_option) {
    $valid_option = trim($valid_option, ' ');

    switch ($valid_option) {
      case '0.0.0.0':
        // IP --> Check if we have an IP /// , FILTER_FLAG_IPV4
        if (filter_var($param, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
          return true;
        }
        break;
      
      case 'TRG':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 3) {
          if (ctype_alpha($param)) {
            return true;
          }
        }
        break;

      case 'len32':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 32) {
          if (ctype_alnum($param)) {
            return true;
          }
        }
        break;

      case 'len64':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 64) {
          if (ctype_alnum($param)) {
            return true;
          }
        }
        break;
      
      case '':
        // Void
        return true;
        break;

      default:
        // param == validparam
        if ($param == $valid_option) {
          return true;
        }
        break;
    }
  }

  return false;
}

/* Host : Bind Stack to Host (completing the Host registering process)
** Analyze POST
** stack_UID --> Fetch ID to insert it within HOST
** host_UID --> To update the correct one
** Last seen : Generate
*/ 

// TODO 
// Make sure we cannot register host multiple stacks on a host
// Make sure we cannot create a second stack that is normally assigned to a host.

// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // STEP 1
  // Fetch API & Validate
  foreach (getallheaders() as $name => $value) {
    if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
  }
  isset($uids->reqBy) ? : dieAfterNotif('x-auth-apiKey', 'AUTH');

  $validateApiBlob = validateApiKey($uids->reqBy);

  // STEP 2
  // Validate Params
  $post_params = array(
    "stackUID" => isset($_POST['stackUID']) ? $_POST['stackUID'] : dieAfterNotif('stackUID', 'POST'),
    "hostUID" => isset($_POST['hostUID']) ? $_POST['hostUID'] : dieAfterNotif('hostUID', 'POST')
  );

  $accepted_values = array(
    "stackUID" => "len32, len64",
    "hostUID" => "len32, len64"
  );

  foreach ($post_params as $post_key => $post_param) {
    if (validateParametters($post_param, $accepted_values[$post_key]) == false) {
      // Display helper
      echo '{', PHP_EOL, '"message": "Helper: \'' . $post_param . '\' is not contained within allowed parameters : \'' . $accepted_values[$post_key] . '\' ."', PHP_EOL, '}';
      die();
    }
  }

  // STEP 3
  // Get Stack ID from Stack->ReadOneFromUID()

  $stacks->stacks_UID = $post_params['stackUID'];
  $stacks->readOneFromUID();
  $stack_arr = array (
    "ID" => $stacks->stacks_ID,
    "NAME" => $stacks->stacks_name,
    "CREATED" => $stacks->stacks_created,
    "UPDATED" => $stacks->stacks_updated,
    "STACK_UID" => $stacks->stacks_UID,
    "HOSTED_ON" => $stacks->stacks_hostedOn,
    "HOSTING_DC" => $stacks->stacks_hostingDC,
    "NB_STACK_VM" => $stacks->stacks_nbStackVM,
    "NB_STACK_VM_ON" => $stacks->stacks_nbStackVMOn,
    "NB_VMS_ONLINE" => $stacks->stacks_nbVMOnline,
    "NB_VMS_AVAIL" => $stacks->stacks_nbVMAvail,
    "REG_STATUS" => $stacks->stacks_regStatus,
    "STATUS" => $stacks->stacks_status,
    "PROV_STATUS" => $stacks->stacks_provStatus,
    "PROV_JOB_STATUS" => $stacks->stacks_provJobStatus,
    "PROV_JOB_PENDING" => $stacks->stacks_provJobPending,
    "PROV_JOB_RUNNING" => $stacks->stacks_provJobRunning,
    "LAST_SEEN" => $stacks->stacks_lastSeen
  );

  if (is_null($stack_arr['ID'])) {
    // Null
    echo '{', PHP_EOL, '"error": "Stack UID provided (' . $post_params['stackUID'] . ') does not matches with any known Stack!"', PHP_EOL, '}';
    die();
  }


  // STEP 4
  // Check if Stack ID is already registered on a Host
  $hosts->host_hostingStack = $stack_arr['ID'];
  $hosts->readOneFromHostingStackID();

  if (is_null($hosts->host_ID) == false) {
    echo '{', PHP_EOL, '"error": "This stack (' . $post_params['stackUID'] . ') is already registred with another host - aborting. "', PHP_EOL, '}';
    die();
  }

  // STEP 5
  // Insert Stack_ID within HOST WHERE UID = UID
  // Set Host to registered
  $hosts->host_hostUID = $post_params['hostUID'];
  $hosts->host_hostingStack = $stack_arr['ID'];
  $hosts->host_lastSeen = date('Y-m-d H:i:s');

  if($hosts->bindStackToHost() === true) {
    // Success
    $message = "Successfully binded Stack to Host!";
    $error = false;
  } else {
    $message = "Error while trying to bind Stack to Host!";
    $error = true;
  }

  $host_arr = array(
    "message" => $message,
    "error" => $error,
    "HOST_UID" => $hosts->host_hostUID,
    "STACK_UID" => $post_params['stackUID'],
    "LAST_SEEN" => $hosts->host_lastSeen
  );

  print_r(json_encode($host_arr));

} else {
  echo '{', PHP_EOL, '"error": "Request method : ' . $_SERVER['REQUEST_METHOD'] . ' not allowed."', PHP_EOL, '}';
  die();
}
//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
//$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

## Global
$apiKeys->timestamp = date('Y-m-d H:i:s');

?>