<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../../config/database_multiplicity.php';

// instantiate uids object
include_once '../../objects/uids.php';
include_once '../../objects/users.php';
include_once '../../objects/hosts.php';
include_once '../../objects/services.php';
include_once '../../objects/apikeys.php';
include_once '../../objects/apilogs.php';

include_once '../../lib/apiServices.php';

$api_Service = 'host-register';

$database = new Database();
$db = $database->getConnection();

$uids = new uids($db);        // UniqID
$hosts = new hosts($db);      // Hosts 
$apiKeys = new apiKeys($db);  // apis
$users = new users($db);      // Users
$services = new services($db);  
$apiLogs = new apiLogs($db);

// get posted data
//$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  elseif ($type == 'POST') { echo '{', PHP_EOL, '"message": "Mendatroy variable missing : ' . $paramName . '."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function dieAfterCallbackError($param) {
  echo '{', PHP_EOL, '"error": could not retieve an ID!" --> ' . $param . '."', PHP_EOL, '}';
  die(); 
}

// That's when you have an API Key doh ! :D (from webby we dont have one :D)
function getUniqueID($apiKey) {
  $opts = [
    "http" => [
        "method" => "GET",
        "header" => "Accept-language: en\r\n" .
        "x-auth-apiKey: " . $apiKey . "\r\n"
    ]
  ];

  $context = stream_context_create($opts);
  $resp_getUniqueID = file_get_contents('http://127.0.0.1/ws/getUniqId.php?len=32', false, $context);
  $resp_getUniqueID = isset($resp_getUniqueID) ? $resp_getUniqueID : dieAfterCallbackError($resp_getUniqueID);

  //print_r($resp_getUniqueID);
  //die();
  //$lintedResult = explode('{', $resp_getUniqueID);
  //$resp_getUniqueID = '{' . $lintedResult[2];
  $resp_getUniqueID = json_decode($resp_getUniqueID);

  return $resp_getUniqueID; // $resp_getUniqueID->UID needed to fecth the UID
}

function validateParametters($param, $valid_options) {
  $param = trim(strtolower($param), ' ');
  $valid_options_arr = explode(',', $valid_options);

  foreach ($valid_options_arr as $key => $valid_option) {
    $valid_option = trim($valid_option, ' ');

    switch ($valid_option) {
      case '0.0.0.0':
        // IP --> Check if we have an IP /// , FILTER_FLAG_IPV4
        if (filter_var($param, FILTER_VALIDATE_IP, FILTER_FLAG_IPV4)) {
          return true;
        }
        break;
      
      case 'TRG':
        // Trigram --> check if we have a TRG
        if (strlen($param) == 3) {
          if (ctype_alpha($param)) {
            return true;
          }
        }

        break;
      
      case '':
        // Void
        return true;
        break;

      default:
        // param == validparam
        if ($param == $valid_option) {
          return true;
        }
        break;
    }
  }

  return false;
}

/* // NODE : Register
** STEP 1: Create host
** POST containing all infos (Hosting Stack, OS, Site, PubIp, appx loc, Host, Owned by, host UID, Last seen)
** s  | site     |  Delta, Cloud, Home, Laptop
** p  | pubIp    |  10.109.60.10
** a  | approx   |  "Jouy le Moutier"
** h  | hostType |  MUTU, PERSO
** o  | owner    |  DDBUIQ, TRG
** os | OS       |  OSX, Win10, Deb10
*/

// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // The request is using the POST method


  //var_dump($_POST);
  // Fetch Options
  //$opt_site = isset($_POST['type']) ? $_POST['type'] : $type = '';

  $post_params = array(
    "site" => isset($_POST['site']) ? $_POST['site'] : dieAfterNotif('site', 'POST'),
    "pub" => isset($_POST['pub']) ? $_POST['pub'] : dieAfterNotif('pub', 'POST'),
    "appx" => isset($_POST['appx']) ? $_POST['appx'] : dieAfterNotif('appx', 'POST'),
    "htype" => isset($_POST['htype']) ? $_POST['htype'] : dieAfterNotif('htype', 'POST'),
    "owner" => isset($_POST['owner']) ? $_POST['owner'] : dieAfterNotif('owner', 'POST'),
    "os" => isset($_POST['os']) ? $_POST['os'] : dieAfterNotif('os', 'POST'),
  );

  $accepted_values = array(
    "site" => "delta, laptop, TRG",
    "pub" => "0.0.0.0",
    "appx" => "",
    "htype" => "mutu, perso",
    "owner" => 'ddbuiq, TRG',
    "os" => "osx, win10, deb10, deb11, deb12, esxi"
  );

  // STEP 1
  // Looking for apiKey:secret in headers.
  foreach (getallheaders() as $name => $value) {
    if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
  }
  isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

  // STEP 2
  // Validate key
  $validateApiBlob = validateApiKey($uids->reqBy);

  // STEP 3
  // Validate params : Helper accepted, we're auth'd
  foreach ($post_params as $post_key => $post_param) {
    if (validateParametters($post_param, $accepted_values[$post_key]) == false) {
      // Display helper
      echo '{', PHP_EOL, '"message": "Helper: \'' . $post_param . '\' is not contained within allowed parameters : \'' . $accepted_values[$post_key] . '\' ."', PHP_EOL, '}';
      die();
    }
  }

  // STEP 4
  // Get UID to create Host
  $guid_host_resp = getUniqueID($uids->reqBy);
  $uid_host_raw = $guid_host_resp->UID;
  $uid_host_reqBy = $guid_host_resp->REQ_BY_NAME;

  //print_r($post_params);
  //print_r($validateApiBlob);
  //print_r($guid_resp);

  // STEP 5
  // Check if user don't exceed maximum allowed hosts
  $hosts->host_ownedBy = $post_params['owner'];
  $hosts->countActiveStacksForUser();
  $host_count=$hosts->host_retCount;
  //var_dump($hosts->host_retCount);

  if ($host_count >= $maximumStacksAllowedPerUser) {
    // Maximum Stack for user exceeded
    echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
    die();
  }

  // STEP 6
  // Create Host envelop
  $hosts->host_hostingStack=0;
  $hosts->host_os=$post_params['os'];
  $hosts->host_site=$post_params['site'];
  $hosts->host_pubIP=$post_params['pub'];
  $hosts->host_appxLocation=$post_params['appx'];
  $hosts->host_hostType=$post_params['htype'];
  $hosts->host_ownedBy=$post_params['owner'];
  $hosts->host_hostUID=$uid_host_raw;
  $hosts->host_lastSeen='0000-00-00 00:00:00';

  if ($hosts->create()) {
    $message = 'Host envelop successfully created.';
    $error = false;
  } else {
    $message='Something went wrong while creating host envelop.';
    $error = true;
  }

  $host_arr = array(
    "message" => $message,
    "error" => $error,
    "hosts_count" => $host_count,
    "OS" => $hosts->host_os,
    "SITE" => $hosts->host_site,
    "PUB_IP" => $hosts->host_pubIP,
    "LOC_APPX" => $hosts->host_appxLocation,
    "HOST_TYPE" => $hosts->host_hostType,
    "OWNED_BY" => $hosts->host_ownedBy,
    "HOST_UID" => $hosts->host_hostUID,
    "HOSTING_STACK" => $hosts->host_hostingStack,
    "LAST_SEEN" => $hosts->host_lastSeen
  );

  print_r(json_encode($host_arr));

} else {
  echo '{', PHP_EOL, '"error": "Request method : ' . $_SERVER['REQUEST_METHOD'] . ' not allowed."', PHP_EOL, '}';
  die();
}

//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
//$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

## Global
$apiKeys->timestamp = date('Y-m-d H:i:s');

?>
