<?php
//
// generate a standard 13 digit UID
// Option : ?len=XX --> Will generate a XX lenght UID
// Max : BDD is set to store a 64 digit UID tho

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);


// required headers
header("Access-Control-Allow-Origin: *");
header("Content-Type: application/json; charset=UTF-8");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Max-Age: 3600");
header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With");

// get database connection
include_once '../config/database_multiplicity.php';

// instantiate uids object
include_once '../objects/uids.php';
include_once '../objects/users.php';
include_once '../objects/services.php';
include_once '../objects/apikeys.php';
include_once '../objects/apilogs.php';

include_once '../lib/apiServices.php';

$api_Service = 'service-api';

$database = new Database();
$db = $database->getConnection();

$apiKeys = new apiKeys($db);
$users = new users($db);

/* Service API
**  Authenticate a web-session
**    OK : Provide USER associated API Key to browser
**    NOK : fail
**  Note : a generic-web-auth-token is created alongside a USERID + SECRET uppon user creation
*/

// get posted data
$data = json_decode(file_get_contents("php://input"));

function dieAfterNotif($paramName, $type = 'GET') {
  if ($type == 'AUTH') { echo '{', PHP_EOL, '"message": "Could not authenticate request! Header parameter : ' . $paramName . ' missing."', PHP_EOL, '}'; }
  elseif ($type == 'FETCH') { echo '{', PHP_EOL, '"message": "Could not find any matching key! User: ' . $paramName . '."', PHP_EOL, '}'; }
  elseif ($type == 'INACTIVE') { echo '{', PHP_EOL, '"message": "Key is not active! User: ' . $paramName . '."', PHP_EOL, '}'; }
  elseif ($type == 'MISSMATCH') { echo '{', PHP_EOL, '"message": "Inconsistancy found! User: ' . $paramName . '."', PHP_EOL, '}'; }
  else { echo '{', PHP_EOL, '"message": "Param missing : ' . $paramName . '."', PHP_EOL, '}'; }
  die();
}

function dieAfterCallbackError($param) {
  echo '{', PHP_EOL, '"error": could not retieve a key for this account!" --> ' . $param . '."', PHP_EOL, '}';
  die(); 
}

$__success = false;
$__message = '';

// Fetch Headers Parameters
foreach (getallheaders() as $name => $value) {
  if ($name == 'web-user-trg') { $users->reqTrigram = $value;}
  if ($name == 'web-user-secret') { $users->reqSecret = $value;}
}
isset($users->reqTrigram) ?  : dieAfterNotif('web-user-trg', 'AUTH');
isset($users->reqSecret) ?  : dieAfterNotif('web-user-secret', 'AUTH');

// Fetch Options
$param =  isset($_GET['p']) ? $_GET['p'] : $param = '';


// STEP 1 : Autenticate User & Retrive ID
$users->getUserIDFromTrigram_secured();

// STEP 2 : Validate User --> Active, TRG=REQ, WS=REQWS fetch API Where foreign ID is me
if ($users->trigram == $users->reqTrigram && $users->reqSecret == $users->webSecret) {
  if ($users->isActive == '1') {
    $apiKeys->foreignID = $users->userID; // store the USER_ID within
    $apiKeys->retrieveAPIKeyFromUserID(); // Retrieved API Key

    if ($apiKeys->isUser == '1') {
      // Fetch associated api key ! :)
      $__success = true;
      $__message = 'Successfully fetched user API Key from web-user-secret';
    } else {
      // not a user key
      dieAfterNotif($users->reqTrigram, 'FETCH');
    }

  } else {
    // user inactive
    dieAfterNotif($users->reqTrigram, 'INACTIVE');
  }
} else {
  // missmatch
    dieAfterNotif($users->reqTrigram, 'MISSMATCH');
}

// STEP 3 : Switch Case, regarding the API
if ($__success == true) {
  switch ($param) {
    case 'fetch-api':
      $response_array = array(
        "message" => $__message,
        "USR_TRIGRAM" => $users->trigram,
        "USR_ACTIVE" => $users->isActive,
        "API_KEY" => $apiKeys->apiKey,
        "API_ACTIVE" => $apiKeys->isActive
      );
      print_r(json_encode($response_array));
      
      break;
    
    default:
      echo '{', PHP_EOL, '"message": "Service ' . $param . ' not found."', PHP_EOL, '}'; 
      break;
  }
}

die();

//$users_arr = array(
//  "ID" => $users->userID,
//  "CREATED" => $users->created,
//  "UPDATED" => $users->updated,
//  "TRIGRAM" => $users->trigram,
//  "TRIGRAM_KEY" => $users->trigramKey,
//  "SESSION_COOKIE" => $users->sessionCookie,
//  "FNAME" => $users->firstName,
//  "LNAME" => $users->lastName,
//  "IS_ACTIVE" => $users->isActive,
//  "WEB_SECRET" => $users->webSecret
//);
////print_r(json_encode($apiKeys_arr));
////die();
//
//
//$apiKeys_arr = array(
//  "ID" => $apiKeys->apiKeyID,
//  "CREATED" => $apiKeys->created,
//  "UPDATED" => $apiKeys->updated,
//  "API_KEY" => $apiKeys->apiKey,
//  "IS_USER" => $apiKeys->isUser,
//  "FOREIGN_ID" => $apiKeys->foreignID,
//  "IS_ACTIVE" => $apiKeys->isActive
//);
//
////print_r(json_encode($apiKeys_arr));
////die();

?>
